-- =======================================
--  Variveis Globais
-- =======================================
GlobInit                           = false
GlobError                          = false
ConfigError                        = false
------------------------------------------
Initialized                        = false
StartTime                          = 0
------------------------------------------
HomunType                          = {Value, String}
AttackRange                        = 1
File_Error                         = "AI/USER_AI/TEMP/Error_H.txt"
---------------------------------------------------------------------------
function AI(myid)
---------------------------------------------------------------------------
	local success
	local error
	local file_temp
	if GlobError then
		success, error = pcall(dofile, "./AI/USER_AI/ERROR HANDLER/AI.lua")
		if not success then
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
		pcall(AI_Sec2, myid)
	elseif not GlobInit then
		success, error = pcall(dofile, "./AI/USER_AI/Const.lua")
		if not success then
			GlobError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
		-----------------------------------------
		success, error = pcall(dofile, "./AI/USER_AI/AI_Default.lua")
		if not success then
			GlobError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
		-----------------------
		--  Carregar Configuraes. [Configurao.]
		-----------------------
		for k, v in next, (Config_Types) do
			if v ~= nil then
				SetDefault(v)
			end
		end
		success, error = pcall(dofile, "./AI/USER_AI/Configurations/Setup.lua")
		if not success then
			ConfigError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			
		end
		-----------------------------------------
		success, error = pcall(dofile, "./AI/USER_AI/Util.lua")
		if not success then
			GlobError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
		success, error = pcall(dofile, "./AI/USER_AI/AI_DC.lua")
		if not success then
			GlobError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
		-----------------------------
		-----------------------------
		--  Carregar Configuraes. [Configurao.]
		-----------------------------
		success, error = pcall(dofile, "./AI/USER_AI/Configurations/User data/User_Default.lua")
		if not success then
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
		end
		success, error = pcall(dofile, "./AI/USER_AI/Main.lua")
		if not success then
			GlobError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
		-----------------------------------------
		--  Adquirir o tipo de homnculo.
		-----------------------------------------
		HomunType.Value  = GetV(V_HOMUNTYPE, myid)
		HomunType.String = Type[HomunType.Value]
		AttackRange      = GetV(V_ATTACKRANGE, myid)
		if HomunType.String ~= nil then
			Log("meu tipo: "..HomunType.String..", minha distncia de ataque: "..AttackRange..".")
		else
			Log("meu tipo: "..HomunType.Value.." (sem registro na database da AI), minha distncia de ataque: "..AttackRange..".")
			Log("voc pode mandar os dados para o criador da AI, como os IDs e nmeros que aparecem, e as skills, para serem adicionados.")
		end
		-----------------------------------------
		if AttackRange == nil then
			AttackRange = 1
		elseif AttackRange <= 0 then
			AttackRange = 1
		end
		-----------------------------------------
		success, error = pcall(AI_Sec, myid)
		if not success then
			GlobError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
		GlobInit = true
	else
		success, error = pcall(AI_Sec, myid)
		if not success then
			GlobError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
	end
end