-----------------------------------------------------
LastGSChk = 0
-------------------------
function DetectDC_ID()
-----------------------------------------------------
	local time_now = GetTick()
	local delta    = time_now - LastGSChk
	
	if LastGSChk == 0 then 
		LastGSChk = time_now 
	elseif (delta < 10000) then 
		return
	end

	delta = time_now - DC_OnOffCheck
	if delta < 15000 then
		return
	end

	LastGSChk = time_now
	
	local f_in = io.open("AI/USER_AI/ID DATA/DC_ID_On.txt", "r")
	if f_in ~= nil then
		f_in:close()
		-- Log("arquivo com IDs para desconectar detectado. Verificando se h GS ou MVP.")
		local success
		local error
		success, error = pcall(ConstGSCheck)
		if not success then
			Log(error, true)
			return
		end
	elseif DC_Checked == true then
		for i,v in pairs (DC_ID) do
			DC_ID[i] = nil
		end
		DC_HP   = 0
		DC_HP_H = 0
		DC_Time = 0
		DC_Checked = false
		Log("arquivo 'DC_ID_On.txt' no est presente: cancelou desconexo automtica.", true)
	else
		-- Log("Anti-GS desligado.")
	end
end
-----------------------------------------------------
DC_ID   = {}
DC_HP   = 0
DC_HP_H = 0
DC_Time = 0
DC_Checked       = false
DC_OnOffCheck    = 0
-------------------------
function ConstGSCheck()
-----------------------------------------------------
	if DC_OnOffCheck == 0 then
		DC_OnOffCheck = GetTick()
	end
	local delta = GetTick() - DC_OnOffCheck
	local f_in
	if not DC_Checked then
		for i,v in pairs (DC_ID) do
			DC_ID[i] = nil
		end
		DC_HP   = 0
		DC_HP_H = 0
		DC_Time = 0
		f_in = io.open("AI/USER_AI/ID DATA/DC_ID_On.txt", "r")
		if f_in ~= nil then
			ln = f_in:read()
			nbr = tonumber(ln)
			if nbr ~= nil then
				DC_HP = nbr
			end
			ln = f_in:read()
			nbr = tonumber(ln)
			if nbr ~= nil then
				DC_HP_H = nbr
			end
			ln = f_in:read()
			nbr = tonumber(ln)
			if nbr ~= nil then
				DC_Time = GetTick() + nbr
			end
			ln = f_in:read()
			while ln ~= nil do
				nbr = tonumber(ln)
				if nbr ~= nil then
					DC_ID[nbr] = 1
				end
				ln = f_in:read()
			end
			f_in:close()
			DC_Checked = true
			Log("iniciar desconexo automtica:", true)
			Log("sair quando o percentual de HP do dono for menor ou igual a "..DC_HP.." e do homnculo, "..DC_HP_H..", passar "..DC_Time - GetTick().." ms (desde o aparecimento do homunculus), ou aparecer um monstro da lista.", true)
		end
	else
		if delta >= 15000 then
			if not FileExists("AI/USER_AI/ID DATA/DC_ID_On.txt") then
				for i,v in pairs (DC_ID) do
					DC_ID[i] = nil
				end
				DC_HP   = 0
				DC_HP_H = 0
				DC_Time = 0
				DC_Checked = false
				Log("cancelou desconexo automtica.", true)
			else
				f_in = io.open("AI/USER_AI/ID DATA/DC_ID_On.txt", "r")
				if f_in ~= nil then
					for i,v in pairs (DC_ID) do
						DC_ID[i] = nil
					end
					ln = f_in:read()
					nbr = tonumber(ln)
					if nbr ~= nil then
						DC_HP = nbr
					end
					ln = f_in:read()
					nbr = tonumber(ln)
					if nbr ~= nil then
						DC_HP_H = nbr
					end
					ln = f_in:read()
					nbr = tonumber(ln)
					if nbr ~= nil then
						if DC_Time == 0 then
							DC_Time = GetTick() + nbr
						end
					end
					ln = f_in:read()
					while ln ~= nil do
						nbr = tonumber(ln)
						if nbr ~= nil then
							DC_ID[nbr] = 1
						end
						ln = f_in:read()
					end
					f_in:close()
				end
			end
			DC_OnOffCheck = GetTick()
			pcall(io.close, "AI/USER_AI/ID DATA/DC_ID_On.txt")
		end
	end
	for i, v in ipairs(GetActors()) do
		if IsMonster(v) == 1 then
			if DC_ID[GetV(V_HOMUNTYPE, v)] ~= nil then
				Log("sair: encontrado o monstro do tipo "..GetV(V_HOMUNTYPE, v)..".", true)
				os.exit(0)
				return
			end
		end
	end
	if (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 <= DC_HP_H then
		Log("sair: HP do homnculo baixo.", true)
		os.exit(0)
		return
	end
	if (GetV(V_HP, OwnerID) / GetV(V_MAXHP, OwnerID)) * 100 <= DC_HP then
		Log("sair: HP do dono baixo.", true)
		os.exit(0)
		return
	end
	if (GetTick() - DC_Time) >= 0 and DC_Time ~= 0 then
		Log("sair: acabou o tempo.", true)
		os.exit(0)
		return
	end
end