-- =======================================
--  Variveis Globais
-- =======================================
GlobInit                           = false
GlobError                          = false
------------------------------------------
Initialized                        = false
StartTime                          = 0
------------------------------------------
MercType                           = 0
AttackRange                        = 1
File_Error                         = "AI/USER_AI/TEMP/Error_A.txt"
LstError = ""
---------------------------------------------------------------------------
function AI(myid)
---------------------------------------------------------------------------
	local success
	local error
	local file_temp
	if GlobError then
		success, error = pcall(dofile, "./AI/USER_AI/ERROR HANDLER/AI_M.lua")
		if not success then
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
		pcall(AI_Sec2, myid)
	elseif not GlobInit then
		success, error = pcall(dofile, "./AI/USER_AI/Const.lua")
		if not success then
			GlobError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
		-----------------------------------------
		success, error = pcall(dofile, "./AI/USER_AI/AI_Default.lua")
		if not success then
			GlobError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
		-----------------------
		--  Carregar Configuraes. [Configurao.]
		-----------------------
		for k, v in next, (Config_Types) do
			if v ~= nil then
				SetDefault(v)
			end
		end
		success, error = pcall(dofile, "./AI/USER_AI/Configurations/Setup.lua")
		if not success then
			ConfigError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			
		end
		-----------------------------------------
		success, error = pcall(dofile, "./AI/USER_AI/Util.lua")
		if not success then
			GlobError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
		success, error = pcall(dofile, "./AI/USER_AI/AI_M_Skills.lua")
		if not success then
			GlobError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
		-----------------------------
		-----------------------------
		--  Carregar Configuraes. [Configurao.]
		-----------------------------
		success, error = pcall(dofile, "./AI/USER_AI/Configurations/User data/User_Default.lua")
		if not success then
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
		end
		-----------------------------
		-----------------------------
		success, error = pcall(dofile, "./AI/USER_AI/Main.lua")
		if not success then
			GlobError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
		-----------------------------------------
		--  Adquirir o tipo de assistente.
		-----------------------------------------
		MercType = GetV(V_MERTYPE, myid)
		-----------------------------------------
		--  Deteco de assistentes de ROPs.
		-----------------------------------------
		if MercType == 1 then
			local hp = GetV(V_MAXHP, myid)
			local sp = GetV(V_MAXSP, myid)
			if     (hp >= 256)   and (hp <= 323)   and (sp >= 200) and (sp <= 252) then --  Arqueira nv. 1 (comum).
				MercType = 1
			elseif (hp >= 6120)  and (hp <= 7712)  and (sp >= 182) and (sp <= 230) then
				MercType = 201
				Log("ROPs: assitente Mmico.")
			elseif (hp >= 10000) and (hp <= 12600) and (sp >= 221) and (sp <= 279) then
				MercType = 202
				Log("ROPs: assitente Alice.")
			elseif (hp >= 7800)  and (hp <= 9800)  and (sp >= 200) and (sp <= 250) then
				MercType = 203
				Log("ROPs: assitente Egnigem Cenia ou Doppelganger.")
			elseif (hp >= 9800)  and (hp <= 10000) and (sp >= 200) and (sp <= 250) then
				MercType = 204
				Log("ROPs: assitente Eddga.")
			else
				MercType = 200
				Log("ROPs: assitente desconhecido da AI.")
			end
		end
		AttackRange = GetV(V_ATTACKRANGE, myid)
		Log("meu tipo: "..MercType..", minha distncia de ataque: "..AttackRange..".")
		-----------------------------------------
		if AttackRange == nil then
			AttackRange = 1
		elseif AttackRange <= 0 then
			AttackRange = 1
		end
		-----------------------------------------
		success, error = pcall(LoadSkillsForMercenary)
		if not success then
			GlobError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
		-----------------------------------------
		success, error = pcall(AI_Sec, myid)
		if not success then
			GlobError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
		GlobInit = true
	else
		success, error = pcall(AI_Sec, myid)
		if not success then
			GlobError = true
			if error ~= LstError then
				TraceAI(error)
				LstError = error
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
			return
		end
	end
end