LastCheckMob = 0
LastCheckUpd = 0
LastAllyChk  = 0
PassD		 = 0
IsFevDanc    = false
----------------------------------------------------------------------------------------------
-- Compatibilidade com o setup.lua 0.9 a
if Config[2]["RESPAWN_REACT"] == nil then Config[2]["RESPAWN_REACT"] = false end
-- Compatibilidade com o setup.lua 0.9 b
if Config[1]["AS_VAN_BLES"]["PercHP"] == nil then config[1]["AS_VAN_BLES"]["PercHP"] = 0 end
if Config[1]["UPDATE_MOB_ID"] == nil then config[1]["UPDATE_MOB_ID"] = true end
if Config[2]["USE_MOB_ID"] == nil then Config[2]["USE_MOB_ID"] = true end
if Config[2]["ATK_HI_IDS"] == nil then Config[2]["ATK_HI_IDS"] = false end
if Config[2]["LO_ID_BEHA"] == nil then Config[2]["LO_ID_BEHA"] = BEHA_react end
if Config[2]["LO_ID_WITH"] == nil then Config[2]["LO_ID_WITH"] = WITH_slow_power end
if Config["FILE_DC_LOG"] == nil then Config["FILE_DC_LOG"] = "AI/USER_AI/TEMP/DC.LOG" end
if Config["FILE_ERROR"] == nil then Config["FILE_ERROR"] = "AI/USER_AI/ERROR.LOG" end
if Config["CONFG_VAR_FRIENDS_LOAD"] == nil then Config["CONFG_VAR_FRIENDS_LOAD"] = true end
if Config["CONFG_VAR_FRIENDS_SAVE"] == nil then Config["CONFG_VAR_FRIENDS_SAVE"] = true end
if Config[1]["IGNORE_AMC"] == nil then Config[1]["IGNORE_AMC"] = false end
if Config[1]["IGNORE_AMC_RANGE"] == nil then Config[1]["IGNORE_AMC_RANGE"] = 1 end
if Config[1]["AFK"] == nil then Config[1]["AFK"] = false end
if Config[1]["AFK_TIME"] == nil then Config[1]["AFK_TIME"] = 60000 end
if Config[1]["AFK_TIME_UN"] == nil then Config[1]["AFK_TIME_UN"] = 1 end
if Config[1]["AFK_LOGOFF"] == nil then Config[1]["AFK_LOGOFF"] = false end
if Config[1]["AFK_LOGOFF_TM"] == nil then Config[1]["AFK_LOGOFF_TM"] = 60000 end
if Config[1]["AFK_LOGOFF_UN"] == nil then Config[1]["AFK_LOGOFF_UN"] = 1 end
if Config[1]["AFK_HP"] == nil then Config[1]["AFK_HP"] = false end
if Config[1]["AFK_HP_ALC"] == nil then Config[1]["AFK_HP_ALC"] = 20 end
if Config[1]["AFK_HP_HO"] == nil then Config[1]["AFK_HP_HO"] = 20 end
if Config[1]["ANTIGS_MET"] == nil then Config[1]["ANTIGS_MET"] = 0 end
if Config[1]["ANTIGS_NR"] == nil then Config[1]["ANTIGS_NR"] = 1 end
if Config[1]["ANTIGS_TA"] == nil then Config[1]["ANTIGS_TA"] = false end
if Config[1]["ANTIGS_TH"] == nil then Config[1]["ANTIGS_TH"] = false end
if Config[1]["ANTIGS_SLAVE"] == nil then Config[1]["ANTIGS_SLAVE"] = false end
if Config[1]["ANTIGS_MVP"] == nil then Config[1]["ANTIGS_MVP"] = false end
if Config[1]["ANTIGS_LIST"] == nil then Config[1]["ANTIGS_LIST"] = false end
if Config[1]["ANTI_MOBS"] == nil then Config[1]["ANTI_MOBS"] = false end
if Config[1]["ANTI_MOBS_AFK"] == nil then Config[1]["ANTI_MOBS_AFK"] = false end
if Config[1]["ANTI_MOBS_ALC"] == nil then Config[1]["ANTI_MOBS_ALC"] = false end
if Config[1]["ANTI_MOBS_H"] == nil then Config[1]["ANTI_MOBS_H"] = false end
if Config[1]["ANTI_MOBS_NR"] == nil then Config[1]["ANTI_MOBS_NR"] = 4 end
if Config[1]["DC_LOG"] == nil then Config[1]["DC_LOG"] = true end
if Config[2]["IGNORE_AMC"] == nil then Config[2]["IGNORE_AMC"] = false end
if Config[2]["IGNORE_AMC_RANGE"] == nil then Config[2]["IGNORE_AMC_RANGE"] = 1 end
if Config[2]["IDS_AT_ORD"] == nil then Config[2]["IDS_AT_ORD"] = 0 end
-- Compatibilidade com o setup.lua 0.9 c
if Config[1]["HELP_FRIEND_1ST"] == nil then Config[1]["HELP_FRIEND_1ST"] = true end
if Config[1]["SP_SAFE2ATK"] == nil then Config[1]["SP_SAFE2ATK"] = 0 end
if Config[2]["HELP_FRIEND_1ST"] == nil then Config[2]["HELP_FRIEND_1ST"] = false end
if Config[2]["SP_SAFE2ATK"] == nil then Config[2]["SP_SAFE2ATK"] = 0 end
-------------------------------------------------------------------------------------------------

if Config[2].USE_MOB_ID then
	require(Config.MODULE_DB_MOB_ID)
else
	MobID={}
end

if Config.MODULE_DC_IDS ~= nil and Self == 1 then
	require(Config.MODULE_DC_IDS)
else
	MobID_DC = {}
end

function UpdateMobID(force)	
	local time_now = GetTick()
	local delta = time_now - LastCheckUpd
	if LastCheckUpd == 0 then 
		LastCheckUpd = time_now 
	elseif (delta < 400) and not force then 
		return
	end
	LastCheckUpd = time_now

	local file = io.open(Config.FILE_MOB_UPDATE)
	if not file then return end
	Log("(MercenaryMod.UpdateMobID())Updating MobID on the fly.")
	
	for eq in file:lines() do
		local poscent = string.find(eq, "=")
		local k_temp = tonumber(string.sub(eq, 1, poscent-1))
		local v_temp = tonumber(string.sub(eq, poscent+1))
		if k_temp == nil or v_temp == nil then
			Log("(MercenaryMod.UpdateMobID())Unable to process the string.")
			return
		end
		MobID[k_temp] = v_temp
		Log("(MercenaryMod.UpdateMobID())New Actor: "..k_temp.." ID:"..v_temp.." added to DB.")
	end
	file:close()
	os.remove(Config.FILE_MOB_UPDATE)	
	return
end 

function GetMobIDFromActor(Act)

	if MobID[Act] == nil then
--		Log("MercenaryMod.GetMobIDFromActor("..Act..") == nil. Returning 0.")
		return 0
	else
--		Log("MercenaryMod.GetMobIDFromActor("..Act..") == "..MobID[Act])
		return MobID[Act]
	end
end 

-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function SearchForMobID(force)   -- Verifica inimigos desconhecidos e atualiza Mob_ID.lua e a AI do mercenrio.
--	Como parmetro a funo recebe uma boolean que pode forar a execuo da verificao, caso no haja essa determinao,
--	ela no executa antes de um determinado tempo, para evitar sobrecarga. Quando verificada a existncia de mobs desconhecidos
--	a funo atualiza o arquivo Mob_ID.lua e adiciona esses novos mobs ao arquivo MobUpDate.txt, o que permite a atualizao da
--	AI do mercenrio durante a execuo desta sem que seja recarregado todo o arquivo Mob_ID.lua.
--	A funo no retorna nenhum valor.
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	local time_now = GetTick()
	local delta = time_now - LastCheckMob
	if LastCheckMob == 0 then 
		LastCheckMob = time_now 
	elseif (delta < 300) and not force then 
		return
	end
	LastCheckMob = time_now

--	Log("(MercenaryMod.SearchForMobID())Checking for Mobs...")
	local ID, ID_Motion
	local actors = GetActors()
	local UpdMobID={}
	local NeedToUpdate = false
	local NeedToCleanMobID = false
	for i,v in ipairs(actors) do
		if (IsMonster(v)~=0 and v~= -1) then
			ID = GetV(V_HOMUNTYPE,v)
			ID_Motion = GetV(V_MOTION, v)
			if (((MobID[v] == nil)        -- Mob novo
			or  (MobID[v] ~= ID))         -- ou algum mob alterou sua ID
			and (ID_Motion~=MOTION_DEAD)) -- Mas que no seja um cadaver.
			then
--				if MobID[v] ~= nil then NeedToCleanMobID = true end
				MobID[v]=ID
				UpdMobID[v]=ID
				NeedToUpdate = true
			end
		end
	end 

	if not NeedToUpdate then return end
	Log("(MercenaryMod.SearchForMobID())Write new Mobs to disk...")

	local temp_file = io.open(Config.FILE_MOB_UPDATE, "a+")
	if not temp_file then 
		temp_file = io.open(Config.FILE_MOB_UPDATE, "w")
		if not temp_file then 
			Log("(MercenaryMod.SearchForMobID())Update file not open.")
			return
		end
	end
    
	local main_file = 0
	
	if Config[1].UPDATE_MOB_ID then 
		main_file = io.open(Config.MODULE_DB_MOB_ID, "a+")
		if not main_file then 
			Log("(MercenaryMod.SearchForMobID())Mob_ID.lua not open.")
			temp_file:close()
			return
		end
	end

	for k,v in pairs(UpdMobID) do
		temp_file:write(k.."="..v.."\n")
		if (k >= 50000) and (Config[1].UPDATE_MOB_ID) then main_file:write("MobID["..k.."]="..v.."\n") end
	end
	temp_file:close()
	if Config[1].UPDATE_MOB_ID then main_file:close() end
	
	if NeedToCleanMobID then
		Log("(MercenaryMod.SearchForMobID())Agending Mob_ID cleaner.")
		local clean_file = io.open(Config.FILE_CLEAN_ID, "wb")
		if clean_file then clean_file:close() end
	end
	return
end	

function AddAllyAIToFriends(force)
	if Config.CONFG_VAR_COOP == 0 then return end
	
	local time_now = GetTick()
	local delta = time_now - LastAllyChk
	if LastAllyChk == 0 then 
		LastAllyChk = time_now 
	elseif (delta < 5000) and not force then 
		return
	end
	LastAllyChk = time_now
	
	Log("(MercenaryMod.AddAllyAIToFriends())Going on.") -- CONFG_VAR_COOP ="..CONFG_VAR_COOP..".")
	if Friends[Config.CONFG_VAR_COOP] == nil then
		Log(" CONFG_VAR_COOP = "..Config.CONFG_VAR_COOP..", Friends[CONFG_VAR_COOP] = nil")
	else
		Log(" CONFG_VAR_COOP = "..Config.CONFG_VAR_COOP..", Friends[CONFG_VAR_COOP] = "..Friends[Config.CONFG_VAR_COOP])
	end
	
	local f_in, nbr, ally_ai
	
	if Self == 1 then ally_ai = 2 else ally_ai = 1 end
		
	if (Config.CONFG_VAR_COOP == 1) or (GetV(V_POSITION, Config.CONFG_VAR_COOP) == -1) then
		
		f_in = io.open(Config[ally_ai].FILE_MYID, "r") 		
		
		if f_in then
			nbr = tonumber(f_in:read())
			Log("(MercenaryMod.AddAllyAIToFriends())New ID: "..nbr..".")
			f_in:close()
		else 
			Log("(MercenaryMod.AddAllyAIToFriends())Unable to open ID file.")
			Config.CONFG_VAR_COOP = 1
			return
		end
		
		if GetV(V_POSITION,nbr) ~= -1 then
			Config.CONFG_VAR_COOP = nbr
			Friends[Config.CONFG_VAR_COOP] = Config.CONFG_VAR_COOP
			Log("(MercenaryMod.AddAllyAIToFriends())Ally AI Added.")
			return
		else
			Log("(MercenaryMod.AddAllyAIToFriends())Ally AI not find, removing ID.")
			os.remove(Config[ally_ai].FILE_MYID)
			Config.CONFG_VAR_COOP = 1
			return
		end
	end
	
	Friends[Config.CONFG_VAR_COOP] = Config.CONFG_VAR_COOP
	return
end

function MercDancing(Mx_loc, My_loc)
	
	ResultX = Mx_loc
	ResultY = My_loc	
	
	if Config[Self].CONFG_VAR_DANC ~= 2 then return ResultX, ResultY end
	
	if (Self_Per_SP < Config[Self].CONFG_VAR_DANC_SP) or 
	   (Self_Per_HP < Config[Self].CONFG_VAR_DANC_HP) then
	   return ResultX, ResultY
	end
	
	IsFevDanc = true
	
	local Ex_loc, Ey_loc = GetV(V_POSITION, MyEnemy)
	
	-- diagonais
	if math.abs(Mx_loc - Ex_loc) == math.abs(My_loc - Ey_loc) then
		if Mx_loc > Ex_loc then
			if My_loc > Ey_loc then
				if PassD == 1 then
					ResultX = Mx_loc
					ResultY = My_loc - 1
					PassD = 0
					return ResultX, ResultY
				else
					ResultX = Mx_loc - 1
					ResultY = My_loc
					PassD = 1
					return ResultX, ResultY
				end
			else
				if PassD == 1 then
					ResultX = Mx_loc - 1
					ResultY = My_loc
					PassD = 0
					return ResultX, ResultY
				else
					ResultX = Mx_loc
					ResultY = My_loc + 1
					PassD = 1
					return ResultX, ResultY
				end
			end
		else
			if My_loc > Ey_loc then
				if PassD == 1 then
					ResultX = Mx_loc
					ResultY = My_loc - 1
					PassD = 0
					return ResultX, ResultY
				else
					ResultX = Mx_loc + 1
					ResultY = My_loc
					PassD = 1
					return ResultX, ResultY
				end
			else
				if PassD == 1 then
					ResultX = Mx_loc + 1
					ResultY = My_loc
					PassD = 0
					return ResultX, ResultY
				else
					ResultX = Mx_loc
					ResultY = My_loc + 1
					PassD = 1
					return ResultX, ResultY
				end
			end
		end
	end
	
-- laterais inclinadas
	if math.abs(Mx_loc - Ex_loc) > math.abs(My_loc - Ey_loc) then
		if PassD == 1 then
			ResultX = Mx_loc
			ResultY = My_loc - 1
			PassD = 0
			return ResultX, ResultY
		else
			ResultX = Mx_loc
			ResultY = My_loc + 1
			PassD = 1
			return ResultX, ResultY
		end	
	end
	
	if math.abs(Mx_loc - Ex_loc) < math.abs(My_loc - Ey_loc) then
		if PassD == 1 then
			ResultX = Mx_loc - 1
			ResultY = My_loc
			PassD = 0
			return ResultX, ResultY
		else
			ResultX = Mx_loc + 1
			ResultY = My_loc
			PassD = 1
			return ResultX, ResultY
		end	
	end
	
	TraceAI("(MercenaryMod.MercDancing()) Unable to select dancing cell.")
	return GetV(V_POSITION, MyID)
end

-----------------------------------------------------
-- ANTIGS & Controle de DC - rev 04.10.2009
-----------------------------------------------------
-- Globais (estticas)
RefTime    = 0
LastMotion = 0
OwnerAFK   = 0
-----------------------------------------------------
function ConstGSCheck()

	if Self ~= 1 then return end -- somente homunculus
	
	-- ***********************************
	-- Opes de desconexo disponveis apenas no modo AFK.
	if Config[1].AFK then
		
		-- ***********************************
		-- 1: Clculo do tempo e controle do inicio e termino do modo AFK.
		-- 1.A: Inicializao das vriaveis.
		local TimeNow = GetTick()
		
		if (RefTime == nil) or (RefTime == 0) then
			RefTime = TimeNow
		end
		
		if LastMotion == nil then
			LastMotion = Mast_Motion
		end
		-- 1.B: Verificao de alterao de postura do alquimista que cancele o modo AFK.
		if not (((LastMotion == MOTION_STAND) and (Mast_Motion == MOTION_STAND))  or
				((LastMotion == MOTION_HIT  ) and (Mast_Motion == MOTION_HIT  ))  or
				((LastMotion == MOTION_SIT  ) and (Mast_Motion == MOTION_SIT  ))  or
				((LastMotion == MOTION_STAND) and (Mast_Motion == MOTION_HIT  ))  or
				((LastMotion == MOTION_HIT  ) and (Mast_Motion == MOTION_STAND))  or
				((LastMotion == MOTION_SIT  ) and (Mast_Motion == MOTION_HIT  ))) then
			if OwnerAFK ~= 0 then
				Log("Saindo do modo AFK.")
			end
			RefTime = TimeNow
		end
		-- 1.C: Armazena a postura atual para uso no prximo ciclo.
		LastMotion = Mast_Motion
		-- 1.D: Ativa o modo AFK considerando o momento registrado como ultima ao ativa do jogador.
		if (RefTime + Config[1].AFK_TIME) < TimeNow then
			if OwnerAFK == 0 then
				Log("Entrando no modo AFK.")
				OwnerAFK = TimeNow
			end
		else
			OwnerAFK = 0
		end
		
		-- ***********************************
		-- 2: Desconexo por tempo em modo AFK
		if Config[1].AFK_LOGOFF and (OwnerAFK ~= 0) then
			if (OwnerAFK + Config[1].AFK_LOGOFF_TM) < TimeNow then
				-- 2.A: Formata o valor do tempo para salvar no arquivo de Log
				local tempo = Config[1].AFK_LOGOFF_TM
				local unidade = "ms"
				if tempo >= 1000 then
					tempo = tempo / 1000
					unidade = "s"
					if tempo >= 60 then
						tempo = tempo / 60
						unidade = "min"
						if tempo >= 60 then
							tempo = tempo / 60
							unidade = "h"
						end
					end
				end
				-- 2.B: Efetua o comando de desconexo
				Disconect(string.format("Desconectando ao final de %.1d %s AFK.", tempo, unidade))
			end
		end
		
		-- ***********************************
		-- 3: Desconexo por pouco HP
		if Config[1].AFK_HP and (OwnerAFK ~= 0) then
			if (Self_Per_HP < Config[1].AFK_HP_HO ) or
			   (Mast_Per_HP < Config[1].AFK_HP_ALC) then
				Disconect("Desconectado: Pouco HP.")
			end
		end
		
		-- ***********************************
		-- 4: AntiGS Inteligente
		-- Detecta monstros criados com galho seco e desconecta
		-- No  necessrio configurar quais IDs resultam em desconexo, desconecta em qualquer mob GS
		if (Config[1].ANTIGS_MET > 0) and (Config[1].ANTIGS_MET <= 3) and (OwnerAFK ~= 0) then
			
			-- 4.A: AntiGS AFK Agressivo - Desconecta quando qualquer monstro que no possuir ttica cadastrada aparecer na tela
			--      Unica opo disponvel quando usado em um servidor privado
			if Config[1].ANTIGS_MET == 3 or Private_Srv then
				for i,v in ipairs(Scre_Actors) do
					if IsMonster(v) ~= 0 then
						local m_id = GetV(V_HOMUNTYPE, v)
						if Config[1][m_id] == nil then
							Disconect("Desconectado: AntiGS AFK Agressivo. Monstro "..v.." ["..m_id.."] sem ttica cadastrada.")
						end
					end
				end
				
			-- 4.B: AntiGS AFK Semiagressivo - Desloga em mobs sem ttica cadastrada e suspeitos de serem criados por GS
			--      Slaves de minichefe/MVP geram falsos positivos e no funciona em servidores privados
			elseif Config[1].ANTIGS_MET == 2 then
			
				local SuspF      = false
				local m_min_d    = 100
				local MobsSuspGS = {}
				
				for i,v in ipairs(Scre_Actors) do
					-- Verifica monstros normais do mapa sem ttica cadastrada...
					local m_id = GetV(V_HOMUNTYPE,v)
					if (IsMonster(v) ~= 0) and (v > 50000) then						
						if (ANTIGS_IGNORE_MOB[m_id] == nil) and (Config[1][m_id] == nil) then
							-- ...e adiciona suas IDs na tabela de monstros que no causam desconexo...
							ANTIGS_IGNORE_MOB[m_id] = 1
							-- ...para evitar falsos positivos no futuro.
						end
					end
					-- Verifica monstros que podem ter origem de GS e gera uma tabela com eles
					if (IsMonster(v) ~= 0) and (v < 50000) then
						local m_mt = GetV(V_MOTION, v)
						local m_dist = GetDistanceFromOwner(v)
						if (Config[1][m_id] == nil) and (ANTIGS_IGNORE_MOB[m_id] == nil) and (m_mt ~= MOTION_DEAD) then
							if MobsSuspGS[m_id] == nil then
								MobsSuspGS[m_id] = 1
							else
								MobsSuspGS[m_id] = MobsSuspGS[m_id] + 1
							end
							if m_dist < m_min_d then m_min_d = m_dist end
							SuspF = true
						end
					end
				end
				
				if Config[1].ANTIGS_SLAVE and SuspF then
					-- Monstros suspeitos de GS foram encontrados
					-- Caso habiliado, verifica se esses monstros esto em mais de um de cada tipo (Slaves?)
					SuspF = false
					for k,v in pairs(MobsSuspGS) do
						if v > 1 then
							MobsSuspGS[k] = nil
						else
							SuspF = true
						end
					end
				end
				
				if SuspF and m_min_d < 10 then
					-- Existe pelo menos um monstro suspeito de GS que est a menos de 10 clulas do mestre. Desconectar!
					local MensOut = "Desconectado: AntiGS AFK Semiagressivo. Monstro(s): "
					for k,v in pairs(MobsSuspGS) do
						MensOut = MensOut..k.."("..v..") "
					end
					Disconect(MensOut.." atacando.")
				end			
				
			-- 4.C: AntiGS AFK Reativo - Desconecta quando n monstros sem tatica e suspeitos de GS estiverem atacando
			--      Pode falhar em salvar o alquimista da morte
			--      Slaves de minichefe/MVP geram falsos positivos e no funciona em servidores privados
			else -- if Config[1].ANTIGS_MET == 1 then  
				
				local SuspF   = false
				local m_cont  = 0
				local MobsSuspGS = {}
				
				for i, v in ipairs(Scre_Actors) do
					local m_id = GetV(V_HOMUNTYPE,v)
					-- Verifica monstros normais do mapa sem ttica cadastrada...
					if (IsMonster(v) ~= 0) and (v > 50000) then						
						if (ANTIGS_IGNORE_MOB[m_id] == nil) and (Config[1][m_id] == nil) then
							-- ...e adiciona suas IDs na tabela de monstros que no causam desconexo...
							ANTIGS_IGNORE_MOB[m_id] = 1
							-- ...para evitar falsos positivos no futuro.
						end
					end
					-- Verifica monstros que podem ter origem de GS, conta os que estao atacando e gera uma tabela com eles
					if (IsMonster(v) ~= 0) and (v < 50000) then						
						local m_mt = GetV(V_MOTION, v)
						local mtarget = GetV(V_TARGET, v)
						if (Config[1][m_id] == nil)                           and
						   (ANTIGS_IGNORE_MOB[m_id] == nil)                   and
						   (m_mt ~= MOTION_DEAD)                              and
						   (((mtarget == OwnerID) and Config[1].ANTIGS_TA)  or
						    ((mtarget == MyID) and Config[1].ANTIGS_TH)      )then
							if MobsSuspGS[m_id] == nil then
								MobsSuspGS[m_id] = 1
							else
								MobsSuspGS[m_id] = MobsSuspGS[m_id] + 1
							end
							m_cont = m_cont + 1
							SuspF = true
						end
					end
				end
				
				if Config[1].ANTIGS_SLAVE and SuspF then
					-- Monstros suspeitos de GS foram encontrados
					-- Caso habiliado, verifica se esses monstros esto em mais de um de cada tipo (Slaves?)
					SuspF = false
					for k,v in pairs(MobsSuspGS) do
						if v > 1 then
							m_cont = m_cont - v
							MobsSuspGS[k] = nil
						else
							SuspF = true
						end
					end
				end
				
				if SuspF and m_cont >= Config[1].ANTIGS_NR then
					-- O nmero de monstros suspeitos de GS que esto atacando superou o definido. Desconectar!
					local MensOut = "Desconectado: AntiGS AFK Reativo. Monstro(s): "
					for k,v in pairs(MobsSuspGS) do
						MensOut = MensOut..k.."("..v..") "
					end
					Disconect(MensOut.." Total "..m_cont.." atacando.")
				end				
			end
		end	
	end  -- final de: if Config[1].AFK then
	
	-- As prximas opes so sensibilizadas tanto por monstros de GS como monstrs normais dos mapas
	
	-- ***********************************
	-- 5: AntiAtropelo
	-- Funciona limitado pelo modo AFK ou no, conforme a configurao
	if Config[1].ANTI_MOBS then
		if (Config[1].ANTI_MOBS_AFK and (OwnerAFK ~= 0)) or (not Config[1].ANTI_MOBS_AFK) then
			local agress  = 0
			local mtarget = 0
			-- Conta o nmero de monstros atacando o alquimista e/ou o homunclus
			for i,v in ipairs(Scre_Actors) do
				if IsMonster(v) ~= 0 then
					mtarget = GetV(V_TARGET, v)
					if (mtarget == OwnerID) and Config[1].ANTI_MOBS_ALC then
						agress = agress + 1
					end
					if (mtarget == MyID) and Config[1].ANTI_MOBS_H then
						agress = agress + 1
					end
				end
			end
			-- Maior que o valor definido na configurao? Desconectar!
			if agress > Config[1].ANTI_MOBS_NR then
				Disconect("Desconectado: "..agress.." monstros atacando.")
			end
		end
	end
	
	-- ***********************************
	-- 6: Desconexo em MVPs e IDs especficas (modo clssico)
	-- Funciona independentemente de se estar AFK
	if Config[1].ANTIGS_MVP or Config[1].ANTIGS_LIST then
		for i,v in ipairs(Scre_Actors) do
			if IsMonster(v) ~= 0 then
				local m_id = GetV(V_HOMUNTYPE,v)
				-- Se configurado para desconectar ao avistar um MVP
				if Config[1].ANTIGS_MVP then
					if MVP_KS_OK[m_id] ~= nil then
						Disconect("Desconectado: MVP ["..m_id.."] "..v..".")
					end
				end
				-- Se estiver usando o arquivo com a lista para DC
				if Config[1].ANTIGS_LIST then
					if MobID_DC[m_id] ~= nil then
						Disconect("Desconectado ao encontrar monstro "..v.." ["..m_id.."].")
					end
				end
			end
		end
	end	
	-- Fim da funo ConstGSCheck()
end

-----------------------------------------------------
-- Funo que envia o seu argumento para o log (TraceAI), salva um
-- arquivo de mensagem para a GUI e fecha o cliente do Ragnarok
-- Pode ser usada com assistente tambm.
-----------------------------------------------------
function Disconect(string_out)
	-- Para o caso da funo ser invocada sem argumento
	if string_out == nil then
		string_out = "Desconectando..."
	end
	-- Registra o evento no TraceAI.txt
	Log(string_out)
	-- Se configurado para gerar um arquivo de log para a GUI ento o faz
	if Config[1].DC_LOG then
		local file = io.open(Config.FILE_DC_LOG, "w")
		if file then
			file:write(os.date().." - "..string_out.."\n")
			file:close()
		else
			Log("No foi possivel gravar no arquivo "..Config.FILE_DC_LOG)
		end
	end
	-- Fecha o cliente
	os.exit(0)
end
