-- =====================
--  Tticas
-- =====================
Beha_Defend = 1
Beha_Attack = 2
-- ===================================
--  Referncias de Funes C do Jogo
-- ===================================
--[[
function TraceAI(string) end
function MoveToOwner(id) end
function Move(id, x, y)  end
function Attack(id, id)  end
function GetV(V_, id)    end
function GetActors()   end
function GetTick()     end
function GetMsg(id)    end
function GetResMsg(id) end
function SkillObject(id, level, skill, target) end
function SkillGround(id, level, skill, x, y)   end
function IsMonster(id) end
--]]
-- =============================
--  Constantes para Funo GetV
-- =============================
V_OWNER	             = 0
V_POSITION           = 1
V_TYPE               = 2
V_MOTION             = 3
V_ATTACKRANGE        = 4
V_TARGET             = 5
V_SKILLATTACKRANGE   = 6
V_HOMUNTYPE          = 7
V_HP                 = 8
V_SP                 = 9
V_MAXHP              = 10
V_MAXSP              = 11
V_MERTYPE            = 12
-- =====================
--  Homnculos
-- =====================
Type = {}
------------------------ 
Type[1]            = "LIF"
Type[2]            = "AMISTR"
Type[3]            = "FILIR"
Type[4]            = "VANILMIRTH"
Type[5]            = "LIF2"
Type[6]            = "AMISTR2"
Type[7]            = "FILIR2"
Type[8]            = "VANILMIRTH2"
Type[9]            = "LIF_H"
Type[10]           = "AMISTR_H"
Type[11]           = "FILIR_H"
Type[12]           = "VANILMIRTH_H"
Type[13]           = "LIF_H2"
Type[14]           = "AMISTR_H2"
Type[15]           = "FILIR_H2"
Type[16]           = "VANILMIRTH_H2"
Type[48]           = "EIRA"
Type[49]           = "BAYERI"
Type[50]           = "SERA"
Type[51]           = "DIETER"
Type[52]           = "ELEANOR"
------------------------
-- =====================
--  Skills de Homnculos
-- =====================
Skills_Homun = {}
------------------------
--  Amistr
------------------------
Skills_Homun[8006] = {SkillID = 8006, String = "AS_AMI_BULW", HowLast = 30000, Engaged = false, TimeOut = 0}

Skills_Homun[8005] = {SkillID = 8005, String = "AS_AMI_CAST", HowLast = 300, Engaged = false, TimeOut = 0}

Skills_Homun[8008] = {SkillID = 8008, String = "AS_AMI_BLOO", HowLast = 600000, Engaged = false, TimeOut = 0}

------------------------
--  Filir
------------------------
Skills_Homun[8009] = {SkillID = 8009, String = "AS_FIL_MOON", HowLast = 2000, Engaged = false, TimeOut = 0, Range = 15}

Skills_Homun[8011] = {SkillID = 8011, String = "AS_FIL_ACCL", HowLast = 120000, Engaged = false, TimeOut = 0}

Skills_Homun[8010] = {SkillID = 8010, String = "AS_FIL_FLTT", HowLast = 120000, Engaged = false, TimeOut = 0}

------------------------
--  Lif
------------------------
Skills_Homun[8002] = {SkillID = 8002, String = "AS_LIF_ESCP", HowLast = 35000, Engaged = false, TimeOut = 0}

Skills_Homun[8001] = {SkillID = 8001, String = "AS_LIF_HEAL", HowLast = 5000, Engaged = false, TimeOut = 0}

Skills_Homun[8004] = {SkillID = 8004, String = "AS_LIF_CHNG", HowLast = 360000, Engaged = false, TimeOut = 0}

------------------------
--  Vanilmirth
------------------------
Skills_Homun[8013] = {SkillID = 8013, String = "AS_VAN_CAPR", HowLast = 1800, Engaged = false, TimeOut = 0, Range = 15}

Skills_Homun[8014] = {SkillID = 8014, String = "AS_VAN_BLES", HowLast = 3000, Engaged = false, TimeOut = 0}

------------------------
--  Mutantes
------------------------
Skills_Homun[8017] = {SkillID = 8017, String = "MUTATION_BASEJOB",          HowLast = 0, Engaged = false, TimeOut = 0}

------------------------
--  Sera
------------------------

Skills_Homun[8018] = {SkillID = 8018, String = "MH_SER_SUMMON_LEGION",      HowLast = 60000, Engaged = false, TimeOut = 0}

Skills_Homun[8019] = {SkillID = 8019, String = "MH_SER_NEEDLE_OF_PARALYZE", HowLast = 2000, Engaged = false, TimeOut = 0}

Skills_Homun[8020] = {SkillID = 8020, String = "MH_SER_POISON_MIST",        HowLast = 20000, Engaged = false, TimeOut = 0}

Skills_Homun[8021] = {SkillID = 8021, String = "MH_SER_PAIN_KILLER",        HowLast = 60000, Engaged = false, TimeOut = 0}

------------------------
--  Eira
------------------------
Skills_Homun[8022] = {SkillID = 8022, String = "MH_EIR_LIGHT_OF_REGENE",    HowLast = 600000, Engaged = false, TimeOut = 0}

Skills_Homun[8023] = {SkillID = 8023, String = "MH_EIR_OVERED_BOOST",       HowLast = 90000, Engaged = false, TimeOut = 0}

Skills_Homun[8024] = {SkillID = 8024, String = "MH_EIR_ERASE_CUTTER",       HowLast = 2000, Engaged = false, TimeOut = 0}

Skills_Homun[8025] = {SkillID = 8025, String = "MH_EIR_XENO_SLASHER",       HowLast = 2000, Engaged = false, TimeOut = 0}

Skills_Homun[8026] = {SkillID = 8026, String = "MH_EIR_SILENT_BREEZE",      HowLast = 2000, Engaged = false, TimeOut = 0}

------------------------
--  Eleanor
------------------------
Skills_Homun[8027] = {SkillID = 8027, String = "MH_ELE_STYLE_CHANGE",       HowLast = 1000, Engaged = false, TimeOut = 0}

Skills_Homun[8028] = {SkillID = 8028, String = "MH_ELE_SONIC_CLAW",         HowLast = 1000, Engaged = false, TimeOut = 0}

Skills_Homun[8029] = {SkillID = 8029, String = "MH_ELE_SILVERVEIN_RUSH",    HowLast = 1000, Engaged = false, TimeOut = 0}

Skills_Homun[8030] = {SkillID = 8030, String = "MH_ELE_MIDNIGHT_FRENZY",    HowLast = 1000, Engaged = false, TimeOut = 0}

Skills_Homun[8036] = {SkillID = 8036, String = "MH_ELE_TINDER_BREAKER",     HowLast = 1000, Engaged = false, TimeOut = 0}

Skills_Homun[8037] = {SkillID = 8037, String = "MH_ELE_CBC",                HowLast = 1000, Engaged = false, TimeOut = 0}

Skills_Homun[8038] = {SkillID = 8038, String = "MH_ELE_EQC",                HowLast = 1000, Engaged = false, TimeOut = 0}

------------------------
--  Bayeri
------------------------
Skills_Homun[8031] = {SkillID = 8031, String = "MH_BAY_STAHL_HORN",         HowLast = 2000, Engaged = false, TimeOut = 0}

Skills_Homun[8032] = {SkillID = 8032, String = "MH_BAY_GOLDENE_FERSE",      HowLast = 90000, Engaged = false, TimeOut = 0}

Skills_Homun[8033] = {SkillID = 8033, String = "MH_BAY_STEINWAND",          HowLast = 90000, Engaged = false, TimeOut = 0}

Skills_Homun[8034] = {SkillID = 8034, String = "MH_BAY_HEILIGE_STANGE",     HowLast = 2000, Engaged = false, TimeOut = 0}

Skills_Homun[8035] = {SkillID = 8035, String = "MH_BAY_ANGRIFFS_MODUS",     HowLast = 90000, Engaged = false, TimeOut = 0}

------------------------
--  Dieter
------------------------
Skills_Homun[8039] = {SkillID = 8039, String = "MH_DIE_MAGMA_FLOW",         HowLast = 90000, Engaged = false, TimeOut = 0}

Skills_Homun[8040] = {SkillID = 8040, String = "MH_DIE_GRANITIC_ARMOR",     HowLast = 60000, Engaged = false, TimeOut = 0}

Skills_Homun[8041] = {SkillID = 8041, String = "MH_DIE_LAVA_SLIDE",         HowLast = 20000, Engaged = false, TimeOut = 0}

Skills_Homun[8042] = {SkillID = 8042, String = "MH_DIE_PYROCLASTIC",        HowLast = 180000, Engaged = false, TimeOut = 0}

Skills_Homun[8043] = {SkillID = 8043, String = "MH_DIE_VOLCANIC_ASH",       HowLast = 2000, Engaged = false, TimeOut = 0}
------------------------
-- =====================
--  Assistentes
-- =====================
ARCHER01        = 1		
ARCHER02        = 2			
ARCHER03        = 3	
ARCHER04        = 4
ARCHER05        = 5
ARCHER06        = 6
ARCHER07        = 7
ARCHER08        = 8
ARCHER09        = 9
ARCHER10        = 10
LANCER01        = 11
LANCER02        = 12
LANCER03        = 13
LANCER04        = 14
LANCER05        = 15
LANCER06        = 16
LANCER07        = 17
LANCER08        = 18
LANCER09        = 19
LANCER10        = 20
SWORDMAN01      = 21		
SWORDMAN02      = 22	
SWORDMAN03      = 23
SWORDMAN04      = 24
SWORDMAN05      = 25
SWORDMAN06      = 26
SWORDMAN07      = 27
SWORDMAN08      = 28
SWORDMAN09      = 29
SWORDMAN10      = 30
-- =====================
--  Gestos
-- =====================
------------------------
--  Normais
------------------------
MOTION_STAND    = 0
MOTION_MOVE     = 1
MOTION_ATTACK   = 2
MOTION_DEAD     = 3
MOTION_HIT      = 4
MOTION_PICKUP   = 5
MOTION_SIT      = 6
MOTION_SKILL    = 7
MOTION_CAST     = 8
MOTION_ATTACK2  = 9
------------------------
--  Knight motions
------------------------
MOTION_COUNTER       = 13 --  Counter Attack.
------------------------
--  Hunter motions
------------------------
MOTION_FOCUSED_ARROW = 18
------------------------
--  Alchemist motions
------------------------
MOTION_TOSS          = 12 --  Toss something (spear boomerang, aid potion).
MOTION_BIGTOSS       = 28 --  A heavier toss (slim potions / acid demonstration).
------------------------
--  Bard / Dancer motions
------------------------
MOTION_DANCE         = 16
MOTION_SING          = 17
------------------------
--  Taekwon Kid motions
------------------------
MOTION_TK_LEAP_UP    = 19
MOTION_TK_LEAP_DOWN  = 20
MOTION_TK_LEAP_LAND  = 25

MOTION_TK_STANCE_TORNADO    = 21
MOTION_TK_STANCE_HEELDROP   = 22
MOTION_TK_STANCE_ROUNDHOUSE = 23
MOTION_TK_STANCE_COUNTER    = 24
MOTION_TK_TUMBLING          = 25 --  Same as MOTION_TK_LEAP_LAND.

MOTION_TK_COUNTER           = 26
MOTION_TK_FLYINGKICK        = 27
MOTION_TK_TORNADO           = 30
MOTION_TK_HEELDROP          = 31
MOTION_TK_ROUNDHOUSE        = 32
------------------------
--  Taekwon Master motions
------------------------
MOTION_TKM_PROTECTION       = 33
MOTION_TKM_HEAT             = 34
------------------------
--  Soul Linker motions
------------------------
MOTION_SL_LINK              = 23 --  Casting Link skill.
------------------------
--  Ninja motions
------------------------
MOTION_NJ_BENDING           = 35 --  ?
MOTION_NJ_SKILL             = 36 --  Used a skill.
MOTION_NJ_CASTING           = 37 --  Casting a skill.
------------------------
--  Gunslinger motions
------------------------
MOTION_GS_DESPERADO         = 38
MOTION_GS_COIN              = 39
MOTION_GS_GATLING           = 40
MOTION_GS_CASTING           = 41 --  Casting a skill.
MOTION_GS_FULLBLAST         = 42
-- =====================
--  PvP Database
-- =====================
PlayerType = {}
PlayerType[0]  = "Novice"
PlayerType[1]  = "Swordsman"
PlayerType[2]  = "Mage"
PlayerType[3]  = "Archer"
PlayerType[4]  = "Acolyte"
PlayerType[5]  = "Merchant"
PlayerType[6]  = "Thief"
PlayerType[7]  = "Knight"
PlayerType[8]  = "Priest"
PlayerType[9]  = "Wizard"
PlayerType[10] = "Blacksmith"
PlayerType[11] = "Hunter"
PlayerType[12] = "Assassin"
PlayerType[13] = "Knight (Peco)"
PlayerType[14] = "Crusader"
PlayerType[15] = "Monk"
PlayerType[16] = "Sage"
PlayerType[17] = "Rogue"
PlayerType[18] = "Alchemist"
PlayerType[19] = "Bard"
PlayerType[20] = "Dancer"
PlayerType[21] = "Crusader (Peco)"
PlayerType[22] = "?"
PlayerType[23] = "Super Novice"
PlayerType[24] = "Gunslinger"
PlayerType[25] = "Ninja"
PlayerType[2000] = "Game Master (Male)"
PlayerType[2001] = "Game Master (Female)"
------------------------
PlayerType[45] = "Portal"
-- =====================
--  MVP Database (Permitido KS)
-- =====================
MVP_KS_OK = {}
MVP_KS_OK[1038] = 1 --  "Osiris"
MVP_KS_OK[1039] = 1 --  "Baphomet"
MVP_KS_OK[1046] = 1 --  "Doppelganger"
MVP_KS_OK[1059] = 1 --  "Mistress"
MVP_KS_OK[1086] = 1 --  "Golden Thief Bug"
MVP_KS_OK[1087] = 1 --  "Orc Hero"
MVP_KS_OK[1112] = 1 --  "Drake"
MVP_KS_OK[1115] = 1 --  "Eddga"
MVP_KS_OK[1147] = 1 --  "Maya"
MVP_KS_OK[1150] = 1 --  "Moonlight Flower"
MVP_KS_OK[1157] = 1 --  "Pharaoh"
MVP_KS_OK[1159] = 1 --  "Phreeoni"
MVP_KS_OK[1190] = 1 --  "Orc Lord"
MVP_KS_OK[1251] = 1 --  "Stormy Knight"
MVP_KS_OK[1252] = 1 --  "Garm"
MVP_KS_OK[1272] = 1 --  "Dark Lord"
MVP_KS_OK[1312] = 1 --  "Turtle General"
MVP_KS_OK[1373] = 1 --  "Lord of the Dead"
MVP_KS_OK[1389] = 1 --  "Dracula"
MVP_KS_OK[1399] = 1 --  "Baphomet"
MVP_KS_OK[1418] = 1 --  "Evil Snake Lord"
MVP_KS_OK[1492] = 1 --  "Incantation Samurai"
MVP_KS_OK[1502] = 1 --  "Pori Pori"
MVP_KS_OK[1511] = 1 --  "Amon Ra"
MVP_KS_OK[1583] = 1 --  "Tao Gunka"
MVP_KS_OK[1623] = 1 --  "RSX-0806"
MVP_KS_OK[1630] = 1 --  "White Lady"
MVP_KS_OK[1646] = 1 --  "Lord Knight Seyren"
MVP_KS_OK[1647] = 1 --  "Assassin Cross Eremes"
MVP_KS_OK[1648] = 1 --  "Whitesmith Howard"
MVP_KS_OK[1649] = 1 --  "High Priest Margaretha"
MVP_KS_OK[1650] = 1 --  "Sniper Cecil"
MVP_KS_OK[1651] = 1 --  "High Wizard Kathryne"
MVP_KS_OK[1658] = 1 --  "Egnigem Cenia"
MVP_KS_OK[1685] = 1 --  "Vesper"
MVP_KS_OK[1688] = 1 --  "Lady Tanee"
MVP_KS_OK[1708] = 1 --  "Thanatos"
MVP_KS_OK[1719] = 1 --  "Detardeurus"
MVP_KS_OK[1734] = 1 --  "Kiel D-01"
MVP_KS_OK[1751] = 1 --  "Valkyrie Randgris"
MVP_KS_OK[1768] = 1 --  "Gloom Under Night"
MVP_KS_OK[1779] = 1 --  "Ktullanux"
MVP_KS_OK[1785] = 1 --  "Atroce"
MVP_KS_OK[1802] = 1 --  "High Priest Margaretha"
MVP_KS_OK[1832] = 1 --  "Ifrit"
MVP_KS_OK[1871] = 1 --  "Fallen Bishop Hibram"
MVP_KS_OK[1873] = 1 --  "Beelzebub"
MVP_KS_OK[1874] = 1 --  "Beelzebub"
MVP_KS_OK[1885] = 1 --  "Gopinich"
MVP_KS_OK[1916] = 1 --  "Satan Morroc"
MVP_KS_OK[1917] = 1 --  "Wounded Morroc"
MVP_KS_OK[1956] = 1 --  "Naght Sieger"
-- =============================
--  Constantes de Comandos
-- =============================
NONE_CMD          = 0
MOVE_CMD          = 1
STOP_CMD          = 2
ATTACK_OBJECT_CMD = 3
ATTACK_AREA_CMD   = 4
PATROL_CMD        = 5
HOLD_CMD          = 6
SKILL_OBJECT_CMD  = 7
SKILL_AREA_CMD    = 8
FOLLOW_CMD        = 9
-- =============================
--  Constantes de Configurao
-- =============================
-----------------
--  Porcentagem:
-----------------
AggroHP             = 80 --  Agora alterado durante o jogo.
SkillsMinSP         = 50
-----------------
Time_BetweenMoveCmd = 750
Time_StartDelay     = 5000
--------------------------------