--=========================================================================================
-- MirAI MercMod: Arquivo de configuracao - setup.lua
--=========================================================================================
-- Constantes para acesso a configuracao especifica de homunculos e mercenarios
-- NAO ALTERE AS CONSTANTES SE NAO SOUBER O QUE ESTA FAZENDO
--=========================================================================================
SETUP_LUA_VER = 0.9                -- Desenvolvido por Feverus em set/2008
SETUP_LUA_REL = "d"                -- formatado e lancado em ago/2009
-------------------------------------------------------------------------------------------
-- Matriz de configuracao
-------------------------------------------------------------------------------------------
Config={}
-------------------------------------------------------------------------------------------
-- Homunculus
-------------------------------------------------------------------------------------------
Config[1]={}
-------------------------------------------------------------------------------------------
-- Mercenario
-------------------------------------------------------------------------------------------
Config[2]={}
------------------------------------------------------------------------------------------- 
-- Fim das constantes
--=========================================================================================
-- Modulos
--=========================================================================================
Config["MODULE_AI_H"]              = "./AI/USER_AI/MAIN/AI_H.lua"
Config["MODULE_AI_M"]              = "./AI/USER_AI/MAIN/AI_M.lua"
Config["MODULE_CONST"]             = "./AI/USER_AI/COMMON/Const.lua"
Config["MODULE_UTIL"]              = "./AI/USER_AI/COMMON/Util.lua"
Config["MODULE_DB_PASS"]           = "./AI/USER_AI/CONFIG/PassiveDB.lua"
Config["MODULE_PATROL"]            = "./AI/USER_AI/COMMON/Patrol.lua"
Config["MODULE_SELECTED_MOD"]      = "./AI/USER_AI/COMMON/SelectedMod.lua"
Config["MODULE_MERCENARY_MOD"]     = "./AI/USER_AI/COMMON/MercenaryMod.lua"
Config["MODULE_MERCENARY_SK"]      = "./AI/USER_AI/COMMON/MercSkills.lua"
Config["MODULE_DB_MOB_ID"]         = "./AI/USER_AI/CONFIG/Mob_ID.lua"
Config["MODULE_DC_IDS"]            = "./AI/USER_AI/CONFIG/DC_Ids.lua"
--=========================================================================================
-- Arquivos
--=========================================================================================
Config["FILE_MOB_UPDATE"]          = "AI/USER_AI/TEMP/MobUpDate.txt"
Config["FILE_CLEAN_ID"]            = "AI/USER_AI/TEMP/Clean.txt"
Config["FILE_DC_LOG"]              = "AI/USER_AI/TEMP/DC.LOG"
Config["FILE_ERROR"]               = "AI/USER_AI/ERROR.LOG"
--=========================================================================================
-- Variaveis Gerais
--=========================================================================================
Config["CONFG_VAR_COOP"]           = 1
Config["CONFG_VAR_USE_VDLY"]       = true
Config["CONFG_VAR_FRIENDS_LOAD"]   = true
Config["CONFG_VAR_FRIENDS_SAVE"]   = true
--=========================================================================================
-- Para compatibilidade com as taticas, carrega o modulo que contem suas definicoes
-------------------------------------------------------------------------------------------
require(Config.MODULE_CONST)       -- NAO DEVE SER MODIFICADO
--=========================================================================================
-- Homunculus
--=========================================================================================
-- Configuracao geral
-------------------------------------------------------------------------------------------
Config[1]["CIRCLE_ON_IDLE"]        = 1
Config[1]["FOLLOW_AT_ONCE"]        = 1
Config[1]["HELP_OWNER_1ST"]        = true
Config[1]["KILL_YOUR_ENEMIES_1ST"] = false
Config[1]["LONG_RANGE_SHOOTER"]    = false
Config[1]["HP_PERC_DANGER"]        = 10     -- %
Config[1]["HP_PERC_SAFE2ATK"]      = 10     -- %
Config[1]["OWNER_CLOSEDISTANCE"]   = 2
Config[1]["TOO_FAR_TARGET"]        = 16
Config[1]["SKILL_TIME_OUT"]        = 1000     -- ms
Config[1]["NO_MOVING_TARGETS"]     = false
Config[1]["ADV_MOTION_CHECK"]      = true
Config[1]["CONFG_VAR_DANC"]        = 0
Config[1]["CONFG_VAR_DANC_HP"]     = 11     -- %
Config[1]["CONFG_VAR_DANC_SP"]     = 25     -- %
Config[1]["DEFAULT_BEHA"]          = BEHA_attack_1st
Config[1]["DEFAULT_WITH"]          = WITH_full_power
Config[1]["FILE_MYID"]             = "AI/USER_AI/TEMP/H_ID.txt"
Config[1]["FILE_FRIENDS"]          = "AI/USER_AI/TEMP/H_Friends.txt"
Config[1]["FILE_FOLLOW"]           = "AI/USER_AI/TEMP/H_Follow.lck"
Config[1]["UPDATE_MOB_ID"]         = true
Config[1]["IGNORE_AMC"]            = true
Config[1]["IGNORE_AMC_RANGE"]      = 1
Config[1]["HELP_FRIEND_1ST"]       = false
Config[1]["SP_SAFE2ATK"]           = 0
-------------------------------------------------------------------------------------------
-- Habilidades
-------------------------------------------------------------------------------------------
Config[1]["AS_AMI_BULW"]           = {MinSP=40,Level=5}
Config[1]["AS_AMI_CAST"]           = {MinSP=10,Level=0,IdleTime=120000}
Config[1]["AS_AMI_BLOO"]           = {MinSP=120,Level=0}
Config[1]["AS_FIL_MOON"]           = {MinSP=20,Level=5}
Config[1]["AS_FIL_ACCL"]           = {MinSP=70,Level=0}
Config[1]["AS_FIL_FLTT"]           = {MinSP=70,Level=0}
Config[1]["AS_LIF_HEAL"]           = {MinSP=25,Level=5,OwnerPercHP=50}
Config[1]["AS_LIF_ESCP"]           = {MinSP=40,Level=5}
Config[1]["AS_LIF_CHNG"]           = {MinSP=100,Level=0}
Config[1]["AS_VAN_CAPR"]           = {MinSP=30,Level=5}
Config[1]["AS_VAN_BLES"]           = {MinSP=40,Level=0,PercHP=70}
-------------------------------------------------------------------------------------------
-- Taticas
-------------------------------------------------------------------------------------------
Config[1][1048] = {"Thief Bug Egg", BEHA_attack_last, WITH_no_skill, 5}
Config[1][1047] = {"Peco Peco Egg", BEHA_attack_last, WITH_no_skill, 5}
Config[1][1097] = {"Ant Egg", BEHA_attack_last, WITH_no_skill, 5}
Config[1][1555] = {"Sm. Parasite", BEHA_avoid, WITH_no_skill, 5}
Config[1][1575] = {"Sm. Flora", BEHA_avoid, WITH_no_skill, 5}
Config[1][1579] = {"Sm. Hydra", BEHA_avoid, WITH_no_skill, 5}
Config[1][1589] = {"Sm. Mandragora", BEHA_avoid, WITH_no_skill, 5}
Config[1][1590] = {"Sm. Geographer", BEHA_avoid, WITH_no_skill, 5}
Config[1][1285] = {"WoE Guardian 1", BEHA_avoid, WITH_no_skill, 5}
Config[1][1286] = {"WoE Guardian 2", BEHA_avoid, WITH_no_skill, 5}
Config[1][1287] = {"WoE Guardian 3", BEHA_avoid, WITH_no_skill, 5}
Config[1][1288] = {"WoE Guardian 4", BEHA_avoid, WITH_no_skill, 5}
Config[1][1078] = {"Red Plant", BEHA_react, WITH_no_skill, 5}
Config[1][1079] = {"Blue Plant", BEHA_react, WITH_no_skill, 5}
Config[1][1080] = {"Green Plant", BEHA_react, WITH_no_skill, 5}
Config[1][1081] = {"Yellow Plant", BEHA_react, WITH_no_skill, 5}
Config[1][1082] = {"White Plant", BEHA_react, WITH_no_skill, 5}
Config[1][1083] = {"Shining Plant", BEHA_react, WITH_no_skill, 5}
Config[1][1084] = {"Black Mushroom", BEHA_react, WITH_no_skill, 5}
Config[1][1085] = {"Red Mushroom", BEHA_react, WITH_no_skill, 5}
-------------------------------------------------------------------------------------------
-- AntiGS
-------------------------------------------------------------------------------------------
Config[1]["AFK"]           = false
Config[1]["AFK_TIME"]      = 60000
Config[1]["AFK_TIME_UN"]   = 1
Config[1]["AFK_LOGOFF"]    = false
Config[1]["AFK_LOGOFF_TM"] = 60000
Config[1]["AFK_LOGOFF_UN"] = 1
Config[1]["AFK_HP"]        = false
Config[1]["AFK_HP_ALC"]    = 20
Config[1]["AFK_HP_HO"]     = 20
Config[1]["ANTIGS_MET"]    = 0
Config[1]["ANTIGS_NR"]     = 1
Config[1]["ANTIGS_TA"]     = false
Config[1]["ANTIGS_TH"]     = false
Config[1]["ANTIGS_SLAVE"]  = false
Config[1]["ANTIGS_MVP"]    = false
Config[1]["ANTIGS_LIST"]   = false
Config[1]["ANTI_MOBS"]     = false
Config[1]["ANTI_MOBS_AFK"] = false
Config[1]["ANTI_MOBS_ALC"] = false
Config[1]["ANTI_MOBS_H"]   = false
Config[1]["ANTI_MOBS_NR"]  = 4
Config[1]["DC_LOG"]        = true
--=========================================================================================
-- Mercenario
--=========================================================================================
-- Configuracao geral
-------------------------------------------------------------------------------------------
Config[2]["CIRCLE_ON_IDLE"]        = 0
Config[2]["FOLLOW_AT_ONCE"]        = 1
Config[2]["HELP_OWNER_1ST"]        = true
Config[2]["KILL_YOUR_ENEMIES_1ST"] = false
Config[2]["LONG_RANGE_SHOOTER"]    = false
Config[2]["HP_PERC_DANGER"]        = 30     -- %
Config[2]["HP_PERC_SAFE2ATK"]      = 50     -- %
Config[2]["OWNER_CLOSEDISTANCE"]   = 2
Config[2]["TOO_FAR_TARGET"]        = 14
Config[2]["SKILL_TIME_OUT"]        = 2000     -- ms
Config[2]["NO_MOVING_TARGETS"]     = false
Config[2]["ADV_MOTION_CHECK"]      = false
Config[2]["CONFG_VAR_DANC"]        = 0
Config[2]["CONFG_VAR_DANC_HP"]     = 25     -- %
Config[2]["CONFG_VAR_DANC_SP"]     = 25     -- %
Config[2]["DEFAULT_BEHA"]          = BEHA_react
Config[2]["DEFAULT_WITH"]          = WITH_slow_power
Config[2]["FILE_MYID"]             = "AI/USER_AI/TEMP/M_ID.txt"
Config[2]["FILE_FRIENDS"]          = "AI/USER_AI/TEMP/M_Friends.txt"
Config[2]["FILE_FOLLOW"]           = "AI/USER_AI/TEMP/M_Follow.lck"
Config[2]["USE_MOB_ID"]            = true
Config[2]["ATK_HI_IDS"]            = false
Config[2]["LO_ID_BEHA"]            = BEHA_react
Config[2]["LO_ID_WITH"]            = WITH_slow_power
Config[2]["IGNORE_AMC"]            = false
Config[2]["IGNORE_AMC_RANGE"]      = 1
Config[2]["IDS_AT_ORD"]            = 0
Config[2]["HELP_FRIEND_1ST"]       = false
Config[2]["SP_SAFE2ATK"]           = 0
-------------------------------------------------------------------------------------------
-- Habilidades
-------------------------------------------------------------------------------------------
Config[2][8223]                    = true
Config[2][8207]                    = true
Config[2][8201]                    = true
Config[2][8208]                    = false
Config[2][8214]                    = true
Config[2][8224]                    = false
Config[2][8222]                    = false
Config[2][8232]                    = false
Config[2][8234]                    = false
Config[2][8215]                    = false
Config[2][8216]                    = true
Config[2][8217]                    = true
Config[2][8221]                    = false
Config[2][8219]                    = false
Config[2][8220]                    = false
Config[2][8225]                    = true
Config[2][8235]                    = false
Config[2][8218]                    = true
Config[2][8202]                    = true
Config[2][8203]                    = true
Config[2][8204]                    = false
Config[2][8205]                    = false
Config[2]["SKILLS_FLW"]            = false
Config[2]["SKILLS_FLW_SIT"]        = false
Config[2]["SCPG_HP"]               = 20     -- %
Config[2]["NR_M_EN_AREA"]          = 2
Config[2]["MIN_DIST"]              = 3
Config[2]["CA_MIN_DIST"]           = 3
Config[2]["RESPAWN_REACT"]         = true
-------------------------------------------------------------------------------------------
-- Taticas
-------------------------------------------------------------------------------------------
Config[2][1048] = {"Thief Bug Egg", BEHA_attack_last, WITH_no_skill, 0}
Config[2][1047] = {"Peco Peco Egg", BEHA_attack_last, WITH_no_skill, 0}
Config[2][1097] = {"Ant Egg", BEHA_attack_last, WITH_no_skill, 0}
Config[2][1555] = {"Sm. Parasite", BEHA_avoid, WITH_no_skill, 0}
Config[2][1575] = {"Sm. Flora", BEHA_avoid, WITH_no_skill, 0}
Config[2][1579] = {"Sm. Hydra", BEHA_avoid, WITH_no_skill, 0}
Config[2][1589] = {"Sm. Mandragora", BEHA_avoid, WITH_no_skill, 0}
Config[2][1590] = {"Sm. Geographer", BEHA_avoid, WITH_no_skill, 0}
Config[2][1285] = {"WoE Guardian 1", BEHA_avoid, WITH_no_skill, 0}
Config[2][1286] = {"WoE Guardian 2", BEHA_avoid, WITH_no_skill, 0}
Config[2][1287] = {"WoE Guardian 3", BEHA_avoid, WITH_no_skill, 0}
Config[2][1288] = {"WoE Guardian 4", BEHA_avoid, WITH_no_skill, 0}
Config[2][1078] = {"Red Plant", BEHA_react, WITH_no_skill, 0}
Config[2][1079] = {"Blue Plant", BEHA_react, WITH_no_skill, 0}
Config[2][1080] = {"Green Plant", BEHA_react, WITH_no_skill, 0}
Config[2][1081] = {"Yellow Plant", BEHA_react, WITH_no_skill, 0}
Config[2][1082] = {"White Plant", BEHA_react, WITH_no_skill, 0}
Config[2][1083] = {"Shining Plant", BEHA_react, WITH_no_skill, 0}
Config[2][1084] = {"Black Mushroom", BEHA_react, WITH_no_skill, 0}
Config[2][1085] = {"Red Mushroom", BEHA_react, WITH_no_skill, 0}
--=========================================================================================
-- Final do arquivo de configuracao
--=========================================================================================
