---------------------------------------------------------------
--
-- Homunculus - Extra Add Ons Configurations 
--
--	ConfigAddOn.lua
--
--	Ver.2008/03/11 - V.0.0.3 beta
--
--      by TNT.Nitro
--
---------------------------------------------------------------
-- Parte   Descrio
-- -----   ----------------------------------------------------
--   1     Arremesso de poo no alquimista/creator
--   2     Auto cura com Vitata ou Cruz Impiedosa
--   3     Configurao de Galho Seco - Sair Automatico
--   4     Sair se o HP do alquimista estiver muito baixo
--   5     Desconectar se o humunculo for morrer
--   6     Grito de Guerra automatico
--   7     Usar revelao automtica com carta horong
--   8     Habilitar "dancing" enquanto o Homunculus ataca
--   9     Conjurar Ressucitar Homunculus automaticamente
--  10     Waterball automatico
--  11     Mental Change Automatico para LIF
--  12     Bloodlust automatico para AMISTR
--  13     Castling automatico para AMISTR quando no encontrar 
--         inimigos fara o alquimista "mudar de lugar" como um 
--         passo etrio
--  14     Mudar o Default da MirAI de ATK o padro  sempre Slow_Power
--  15     Constantes extras usadas
---------------------------------------------------------------
 
----PARTE 1 ---------------------------------------
-- Arremessar Poo automatico para o Alquimista/Criador, 1 = ligado, 0 = desligado
AlchAutoPot = 0

-- Configuraes de Arremessar Poo Automatico para Alquimista, skill lvl e hp (valor porcentual)
AS_ALC_PP = {}
AS_ALC_PP.Level   = 4   --> (1=Vermelha, 2=Laranja, 3=Amarela, 4=Branca)
AlchAutoPotHPPerc = 55  --> (em % de HP)

----PARTE 2 ---------------------------------------
-- Cura automatica para o Alquimista/Criador, 1 = ligado, 0 = desligado.
AlchAutoHeal = 0

-- Configuraes de Cura Automatica para Alquimista, skill lvl e hp (valor porcentual)
-- Level 1 para Vitata, level 3 para Cruz
AS_ALC_HEAL = {}
AS_ALC_HEAL.Level = 1
AlchAutoHealHPPerc = 95  
AlchAutoHealSP = 20

----PARTE 2.5 ---------------------------------------
-- CURA COM Caotic Bless - somante para VANIL
AlchHPPercMin = 95    --> se o HP estiver abaixo desse percentual o Vanil ira usar beno caotica para curar  

----PARTE 3 ---------------------------------------
-- Configuraes de ANTI-GALHO SECO para o Alquimista/Criador, 1 = ligado, 0 = desligado.
AlchAutoGalho = 1

-- Configuraes de ANTI-GALHO SECO fechar o jogo Automatico para Alquimista, hp (valor porcentual)
AlchAutoGalhoHPPerc = 100   -- % de HP para desconectar --> para desconectar assim que o monstro for avistado coloque 100
AlchAutoGalhoSP = 0

----PARTE 4 ---------------------------------------
-- Configuraes de HP/SP minimos para o Alquimista/Criador, 1 = ligado, 0 = desligado.
AlchAutoExit = 0

AlchAutoExitHPPerc = 30    -- % minimo de HP do alquimista para desconectar --> 0 = DESABILITADO
AlchAutoExitSP = 0         -- % minimo de HP do alquimista para desconectar --> 0 = DESABILITADO

----PARTE 5 ---------------------------------------
-- Configuraes de HP/SP minimos para o Humunculo, 1 = ligado, 0 = desligado.
HumuncAutoExit = 0

HumuncAutoExitHPPerc = 5  -- % minimo de HP do humunculo para desconectar --> 0 = DESABILITADO
HumuncAutoExitSP = 0       -- % minimo de HP do humunculo para desconectar --> 0 = DESABILITADO

----PARTE 6 ---------------------------------------
-- Grito de Guerra automatico, 1 = ligado, 0 = desligado
AlchAutoUpr = 0

----PARTE 7 ---------------------------------------
-- Usar revelao automtica (util nos rochosos) com carta horong
AlchRevelacao = 0

----PARTE 8 ---------------------------------------
-- Habilitar "dancing" enquanto o Homunculus ataca, 1 = ligado, 0 = desligado
HomuncDancing = 0

-- Configuraes de "dancing", quantidade de HP e SP minimas.
HomuncDancingHP = 2000
HomuncDancingSP = 1

----PARTE 9 ---------------------------------------
-- Conjurar Ressucitar Homunculus automaticamente, 1 = ligado, 0 = desligado
HomuncAutoRess = 1

-- Configuraes de Ressucitar Homunculus, quantidade de HP para comear a conjurar e lvl da skill
-- A habilidade ser usada enquanto o HP do Homunculus estiver menor que o valor (absoluto) de AutoRessHP
AutoRessLvl = 1
AutoRessHP = 1

----PARTE 10 ---------------------------------------
-- Waterball automatico
-- 0 = desligado, 1 = sempre, 2 = apenas antes do homunculus atacar, 3 = apenas depois do homunculus atacar
AutoWaterBall = 0

-- Configurao de Waterball, sp minimo
WaterBallMinSP = 300

----PARTE 11 ---------------------------------------
-- Mental Change Automatico para LIF, 1 = ligado, 0 = desligado
LifAutoMC = 0

-- Configuraes de Mental Change para LIF, sp minimo e skill lvl
AS_LIF_CHANGE = {}
AS_LIF_CHANGE.MinSP=100
AS_LIF_CHANGE.Level=3

----PARTE 12 ---------------------------------------
-- Bloodlust automatico para AMISTR, 1 = ligado, 0 = desligado
AmistrAutoBL = 0

-- Configuraes de Bloodlust para AMISTR, sp minimo e skill lvl
AS_AMI_BLOOD = {}
AS_AMI_BLOOD.MinSP=120
AS_AMI_BLOOD.Level=3

----PARTE 13 ---------------------------------------
-- Castling automatico para AMISTR quando no encontrar inimigos, 1 = ligado, 0 = desligado
AmistrAutoCastling = 0

-- Configuraes de Castling automatico para AMISTR, sp minimo e tempo sem encontrar monstros.
-- A skill ser usada aps AutoCastlingIdleTime ter se passado sem encontrar nenhum inimigo
-- O tempo  medido em milesimos de segundo
-- Funciona muito melhor com "Circle Around Owner" habilitado
AutoCastlingLevel = 5
AutoCastlingMinSP = 10
AutoCastlingIdleTime = 120000

----PARTE 14 ---------------------------------------
-- Na MirAI no da para mudar o Default de ATK para FULL_POWER, fica sempre Slow_Power
-- Aqui vc deixa qual o DEFAULT de opo de ATK
-- Os valores podem ser:
--	WITH_no_skill    -- don't waste SPs for skills
--	WITH_one_skill   -- only one skill in the beginning of the attack
--	WITH_two_skills  -- only two skill in the beginning of the attack
--	WITH_max_skills  -- use skills, until the time out expires
--	WITH_full_power  -- use skills, until there are enough SPs
--	WITH_slow_power  -- use skills after a small delay

NEW_DEFAULT_WITH = WITH_full_power

----PARTE 15 ---------------------------------------
-- ID do Emperium
ID_EMPERIUM = 1288
ID_ZENORC = 1177

