-- =======================================
--  Variveis
-- =======================================
Friends    = {}
TempFriend = {}
------------------------------------------
Ally_AI    = 1
------------------------------------------
---------------------------------------------------------------------------
LastLogTime = 0
LastLogMsg  = ""
------------------------------------------
function Log(string, logfile)
---------------------------------------------------------------------------
	local currtime = GetTick()
	
	local dt = currtime - LastLogTime
	
	if LastLogTime == 0 then dt = 0 end
	
	LastLogTime = currtime
	if LastLogMsg == string then
		return
	else
		LastLogMsg  = string
	end
	------------------------
	local success
	local error
	local file_temp
	------------------------
	if HomunType ~= nil then
		if dt ~= 0 then
			success, error = pcall(TraceAI, ("("..dt.." ms depois) Homnculo: "..string))
			if not success then
				TraceAI(error)
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
		else
			success, error = pcall(TraceAI, ("Homnculo: "..string))
			if not success then
				TraceAI(error)
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
		end
		if logfile then
			pcall(LogFile, string)
		end
	else
		if dt ~= 0 then
			success, error = pcall(TraceAI, ("("..dt.." ms depois) Assistente: "..string))
			if not success then
				TraceAI(error)
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
		else
			success, error = pcall(TraceAI, ("Assistente: "..string))
			if not success then
				TraceAI(error)
				file_temp = io.open(File_Error, "a+")
				if not file_temp then 
					file_temp = io.open(File_Error, "w")
					if not file_temp then 
						return
					end
				end
				file_temp:write(error.."\n")
				file_temp:close()
			end
		end
		if logfile then
			pcall(LogFile, string)
		end
	end
end
---------------------------------------------------------------------------
function LogFile(string)
---------------------------------------------------------------------------
	local file_temp
	if HomunType ~= nil then
		file_temp = io.open("AI/USER_AI/TEMP/Log_H.txt", "a+")
		if not file_temp then 
			file_temp = io.open("AI/USER_AI/TEMP/Log_H.txt", "w")
			if not file_temp then 
				return
			end
		end
		file_temp:write(string.."\n")
		file_temp:close()
	else
		file_temp = io.open("AI/USER_AI/TEMP/Log_A.txt", "a+")
		if not file_temp then 
			file_temp = io.open("AI/USER_AI/TEMP/Log_A.txt", "w")
			if not file_temp then 
				return
			end
		end
		file_temp:write(string.."\n")
		file_temp:close()
	end
end
-- =======================================
--  Identificao de IDs
-- =======================================
---------------------------------------------------------------------------
function IsPlayer(id)
---------------------------------------------------------------------------
	return (id > 100000)
end
---------------------------------------------------------------------------
function HasOfensiveMotion(v, id, hit)
---------------------------------------------------------------------------
	if hit == nil then
		hit = true
	end
	if v == id then
		return false
	end
	if GetV(V_MOTION, v) == MOTION_DEAD or GetV(V_MOTION, id) == MOTION_DEAD then
		return false
	end
	if IsPlayer(v) and PvPHere then
		------------------
		--  Gestos Bsicos:
		------------------
		if    ((GetV(V_MOTION, v) == MOTION_ATTACK
		   or ((GetV(V_MOTION, v) == MOTION_SKILL or GetV(V_MOTION, v) == MOTION_PICKUP) and GetTick() > Time_CanTakeDeadDmg           and GetV(V_MOTION, id) == MOTION_HIT and NoOtherIsAttacking(id, v) )
		   or  GetV(V_MOTION, v) == MOTION_ATTACK2) and GetV(V_TARGET, v) == id)
		   or (GetV(V_MOTION, id) == MOTION_HIT and hit == true and GetTick() > Time_CanTakeDeadDmg and NoOtherIsAttacking(id, v)  and (id == OwnerID or id == MyID or Friends[id] ~= nil)) 
		------------------
		--  Gestos de Personagens:
		------------------
		   or (GetV(V_MOTION, id) == MOTION_HIT and GetV(V_TARGET, v) == id and
		      ((GetV(V_MOTION, v) == MOTION_FOCUSED_ARROW)
		   --or (GetV(V_MOTION, v) == MOTION_TK_STANCE_TORNADO)
		   --or (GetV(V_MOTION, v) == MOTION_TK_STANCE_HEELDROP)
		   --or (GetV(V_MOTION, v) == MOTION_TK_STANCE_ROUNDHOUSE)
		   --or (GetV(V_MOTION, v) == MOTION_TK_STANCE_COUNTER)
		   or (GetV(V_MOTION, v) == MOTION_TK_COUNTER)
		   or (GetV(V_MOTION, v) == MOTION_TK_FLYINGKICK)
		   or (GetV(V_MOTION, v) == MOTION_TK_TORNADO)
		   or (GetV(V_MOTION, v) == MOTION_TK_HEELDROP)
		   or (GetV(V_MOTION, v) == MOTION_TK_ROUNDHOUSE)
		   or (GetV(V_MOTION, v) == MOTION_TKM_HEAT)
		   or (GetV(V_MOTION, v) == MOTION_NJ_SKILL and NoOtherIsAttacking(id, v) )
		   or (GetV(V_MOTION, v) == MOTION_GS_DESPERADO and NoOtherIsAttacking(id, v) )
		   or (GetV(V_MOTION, v) == MOTION_GS_GATLING)
		   or (GetV(V_MOTION, v) == MOTION_GS_FULLBLAST)))
		------------------
		--  Gestos do Usurio:
		------------------
		   or ((GetV(V_MOTION, id) == MOTION_ATTACK         and GetV(V_TARGET, id) == v)
		   or (GetV(V_MOTION, id) == MOTION_ATTACK2        and GetV(V_TARGET, id) == v)
		   or (GetV(V_MOTION, id) == MOTION_SKILL   and GetV(V_MOTION, v) == MOTION_HIT  and GetV(V_TARGET, id) == v and NoOtherIsAttacking(v, id) )
		   and id ~= MyID)
		------------------
		then
			return true
		end
	elseif IsMonster(v) == 1 or PvPHere then
		------------------
		--  Gestos Bsicos:
		------------------
		if     (GetV(V_TARGET, v) == id and
		       (GetV(V_MOTION, v) == MOTION_ATTACK
		   or  GetV(V_MOTION, v) == MOTION_ATTACK2
		   or ((GetV(V_MOTION, v) == MOTION_SKILL or GetV(V_MOTION, v) == MOTION_PICKUP) and GetTick() > Time_CanTakeDeadDmg    and GetV(V_MOTION, id) == MOTION_HIT                            and NoOtherIsAttacking(id, v) )))
		   or (GetV(V_MOTION, id) == MOTION_HIT and hit == true and GetTick() > Time_CanTakeDeadDmg and NoOtherIsAttacking(id, v)   and (id == OwnerID or id == MyID or Friends[id] ~= nil)) 
		------------------
		--  Gestos do Usurio:
		------------------
		   or ((GetV(V_MOTION, id) == MOTION_ATTACK                                      and GetV(V_TARGET, id) == v)
		   or  (GetV(V_MOTION, id) == MOTION_ATTACK2                                     and GetV(V_TARGET, id) == v)
		   or  (GetV(V_MOTION, id) == MOTION_SKILL   and GetV(V_MOTION, v) == MOTION_HIT and GetV(V_TARGET, id) == v and NoOtherIsAttacking(v, id) )
		   and id ~= MyID)
		------------------
		then
			return true
		end
	else
		------------------
		--  Gestos Bsicos:
		------------------
		if   ((GetV(V_MOTION, v) == MOTION_ATTACK
		   or ((GetV(V_MOTION, v) == MOTION_SKILL or GetV(V_MOTION, v) == MOTION_PICKUP) and GetTick() > Time_CanTakeDeadDmg    and GetV(V_MOTION, id) == MOTION_HIT and NoOtherIsAttacking(id, v) )
		   or  GetV(V_MOTION, v) == MOTION_ATTACK2)
		   and GetV(V_MOTION, id) == MOTION_HIT and GetV(V_TARGET, v) == id)
		   or (GetV(V_MOTION, id) == MOTION_HIT and hit == true and GetTick() > Time_CanTakeDeadDmg and NoOtherIsAttacking(id, v)  and (id == OwnerID or id == MyID or Friends[id] ~= nil)) 
		------------------
		--  Gestos do Usurio:
		------------------
		   or ((GetV(V_MOTION, id) == MOTION_ATTACK                                      and GetV(V_TARGET, id) == v)
		   or  (GetV(V_MOTION, id) == MOTION_ATTACK2                                     and GetV(V_TARGET, id) == v)
		   or  (GetV(V_MOTION, id) == MOTION_SKILL   and GetV(V_MOTION, v) == MOTION_HIT and GetV(V_TARGET, id) == v and NoOtherIsAttacking(v, id) )
		   and id ~= MyID and (IsMonster(v) == 1 or PvPHere))
		------------------
		then
			return true
		end
	end
	--Log("o alvo "..v.." no est atacando "..id..".")
	return false
end
---------------------------------------------------------------------------
function AreaSkill(target, caster)
---------------------------------------------------------------------------
	if target == caster then
		return false
	end
	if GetV(V_MOTION, target) == MOTION_DEAD or GetV(V_MOTION, caster) == MOTION_DEAD then
		return false
	end
	local result = false
	if (GetV(V_MOTION, caster) == MOTION_SKILL or Had_MOTION_SKILL[caster] ~= nil) then
		if GetV(V_TARGET, caster) <= 0 then
			if GetV(V_MOTION, target) == MOTION_HIT and NoOneIsTargeting(target, caster) and GetTick() > Time_CanTakeDeadDmg then
				Log("skill de rea: ID ("..caster..") acertou ("..target..").")
				result = true
			end
		else
			if GetV(V_MOTION, target) == MOTION_HIT and NoOneIsTargeting(target, caster) and GetTick() > Time_CanTakeDeadDmg then
				Log("skill de rea: ID ("..caster..") usou uma skill em ("..GetV(V_TARGET, caster)..") mas acertou ("..target..").")
				result = true
			end
		end
	elseif (IsMonster(caster) == 1 or PvPHere) then
		if GetV(V_MOTION, target) == MOTION_HIT and (GetV(V_MOTION, caster) == MOTION_PICKUP or Had_MOTION_PICKUP[caster] ~= nil) and GetTick() > Time_CanTakeDeadDmg then --  Traps...
			Log("skill de rea: ID ("..caster..") usou uma Trap!")
			result = true
		end
	end	
	if result ~= true then
		if target == OwnerID or target == MyID or (target == Ally_AI and Ally_AI > 1) or Friends[target] ~= nil then
			if GetV(V_MOTION, target) == MOTION_HIT and (NoOtherIsAttacking(target, caster) and NoOneIsTargeting(target, caster)) and GetTick() > Time_CanTakeDeadDmg then --  Traps...
				Log("skill de rea: ID ("..target..") est recebendo dano sem ofensores, atacar ID ("..caster..")!")
				result = true
			end
		end
	end
	return result
end
---------------------------------------------------------------------------
Timer_ToStopAttacking        = 0
Timer_ToStopAttacking_Global = 0
Last_Enemy                   = 0
------------------------------------------
function IsNotEnemyAnymore(myEnemy) --  29/06/2011: implantado; 30/06/2011: melhoria na deteco.
---------------------------------------------------------------------------
	if myEnemy == OwnerID or myEnemy == MyID or (Ally_AI > 1 and myEnemy == Ally_AI) then
		Log("o inimigo "..myEnemy.."  um aliado e, portanto, alvo invlido.")
		return true
	end
	if Last_Enemy ~= myEnemy then
		Timer_ToStopAttacking_Global = GetTick() + 30000
	elseif GetTick() >= Timer_ToStopAttacking_Global then
		Timer_ToStopAttacking_Global = GetTick() + 30000
		Log("30 segundos atacando sem o inimigo morrer, verificar outros.")
		return true
	end
	local friend = 0
	if Friends[GetV(V_TARGET, myEnemy)] ~= nil then
		friend = GetV(V_TARGET, myEnemy)
	end
	if ((Timer_ToStopAttacking == 0 
	or (((HasOfensiveMotion(myEnemy, MyID)  or AreaSkill(MyID, myEnemy)
	or    HasOfensiveMotion(OwnerID, myEnemy, false) or AreaSkill(myEnemy, OwnerID)
	or    HasOfensiveMotion(myEnemy, OwnerID)        or AreaSkill(OwnerID, myEnemy)
	or  (friend > 0 
	  and  (((HasOfensiveMotion(friend, myEnemy, false) or AreaSkill(myEnemy, friend)) and (IsMonster(myEnemy) == 1 or PvPHere))
	    or  ((HasOfensiveMotion(myEnemy, friend)        or AreaSkill(friend, myEnemy)) and (IsMonster(myEnemy) == 1 or PvPHere)))))
	and (IsMonster(myEnemy) == 1 or (PvPHere))) ))
	and (GetMyEnemy(MyID)    == myEnemy 
	  or GetEnemyOf(OwnerID) == myEnemy
	  or GetEnemyOf(friend)  == myEnemy  )) or Last_Enemy ~= myEnemy then
		Last_Enemy = myEnemy
		if IsPlayer(myEnemy) and PvPHere then
			Timer_ToStopAttacking = GetTick() + 7000
		elseif IsMonster(myEnemy) then
			Timer_ToStopAttacking = GetTick() + 5000
		else
			Timer_ToStopAttacking = GetTick() + 3000
		end
	elseif CanDoKS ~= myEnemy 
	and ((DefaultBeha ~= Beha_Attack and GetBehavToID_or_Type(myEnemy) ~= "Aggressive") 
	  or (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 <= AggroHP
	  or (GetMyEnemyB(MyID) ~= myEnemy and GetV(V_TARGET, MyID) ~= myEnemy)
	  or (IsMonster(myEnemy) == 0 and (not PvPHere or IsPlayer(myEnemy) == 0))) then
		if  GetTick() >= Timer_ToStopAttacking then
			Timer_ToStopAttacking = 0
			Log("o inimigo "..myEnemy.." no est mais atacando.")
			return true
		end
	end
	if Last_Enemy ~= myEnemy then
		Last_Enemy = myEnemy
	end
	return false
end
---------------------------------------------------------------------------
function NoOneIsTargeting(target, enemy)
---------------------------------------------------------------------------
	if enemy == nil then
		enemy = 0
	end
	for i, v in ipairs(Screen_Actors) do
		if GetV(V_TARGET, v) == target and GetV(V_MOTION, v) ~= MOTION_DEAD and v > 0 and v ~= enemy then
			return false
		end
	end
	return true
end
---------------------------------------------------------------------------
function NoOtherIsAttacking(id1, id2)
---------------------------------------------------------------------------
	if id2 == nil then
		id2 = 0
	end
	for i, v in ipairs(Screen_Actors) do
		if v > 0 and v ~= id2 and v ~= id1 then
			if (GetV(V_TARGET, v) == id1 and
			       (GetV(V_MOTION, v) == MOTION_ATTACK
			   or  GetV(V_MOTION, v) == MOTION_ATTACK2
			   or  GetV(V_MOTION, v) == MOTION_FOCUSED_ARROW
			--   or  GetV(V_MOTION, v) == MOTION_TK_STANCE_TORNADO
			--   or  GetV(V_MOTION, v) == MOTION_TK_STANCE_HEELDROP
			--   or  GetV(V_MOTION, v) == MOTION_TK_STANCE_ROUNDHOUSE
			--   or  GetV(V_MOTION, v) == MOTION_TK_STANCE_COUNTER
			   or  GetV(V_MOTION, v) == MOTION_TK_COUNTER
			   or  GetV(V_MOTION, v) == MOTION_TK_FLYINGKICK
			   or  GetV(V_MOTION, v) == MOTION_TK_TORNADO
			   or  GetV(V_MOTION, v) == MOTION_TK_HEELDROP
			   or  GetV(V_MOTION, v) == MOTION_TK_ROUNDHOUSE
			   or  GetV(V_MOTION, v) == MOTION_TKM_HEAT
			   or (GetV(V_MOTION, v) == MOTION_NJ_SKILL        and GetV(V_MOTION, id1) == MOTION_HIT)
			   or (GetV(V_MOTION, v) == MOTION_GS_DESPERADO    and GetV(V_MOTION, id1) == MOTION_HIT)
			   or  GetV(V_MOTION, v) == MOTION_GS_GATLING
			   or  GetV(V_MOTION, v) == MOTION_GS_FULLBLAST))
			then
				return false
			end
		end
	end
	return true
end
---------------------------------------------------------------------------
function AttackAnyNearMe()
---------------------------------------------------------------------------
	local enemies       = {}
	local enemies_index = 1
	for i, v in ipairs(Screen_Actors) do
		if v > 0 and (v ~= OwnerID and v ~= MyID)
		and not IsOutOfSight(MyID, v)
		and not IsKS(v)
		and    (IsMonster(v) == 1 or PvPHere)
		and    ((Friends[GetV(V_TARGET, v)] ~= nil and (HasOfensiveMotion(v, GetV(V_TARGET, v)) or AreaSkill(GetV(V_TARGET, v), v)))
		or HasOfensiveMotion(v, OwnerID) or AreaSkill(OwnerID, v)
		or HasOfensiveMotion(v, MyID) or AreaSkill(MyID, v))
		then
			enemies[enemies_index] = v
			enemies_index = enemies_index + 1
		end
	end
	enemies[enemies_index] = MyEnemy
	enemies_index = enemies_index + 1
	local dis
	local dis_min = 27
	local result  = MyEnemy
	if GetV(V_MOTION, result) == MOTION_HIT and NoOtherIsAttacking(result) and (GetDistance2(MyID, result) <= AttackRange or math.random(1, 100) <= 15) then
		if math.random(1, 100) <= 55 then
			Attack(MyID, result)
		end
	end
	for i, v in ipairs(enemies) do
		dis = GetDistance2(MyID, v)
		if dis <= dis_min then
			dis_min = dis
			if result ~= MyEnemy and (GetDistance2(MyID, v) <= AttackRange) then
				if math.random(1, 100) <= 55 then
					result  = v
					break
				end
			else
				result  = v
				if (GetV(V_MOTION, v) == MOTION_HIT and math.random(1, 100) <= 55) or math.random(1, 100) <= 25 then
					break
				end
			end
		end
	end
	--Log("atacar o mais prximo: "..result..".")
	Attack(MyID, result)
	return result
end
---------------------------------------------------------------------------
function IsKS(id)
---------------------------------------------------------------------------
	if 0 == IsMonster(id) then return false; end
	if IsPlayer(id) then return false; end
	if id == CanDoKS then return false; end
	--------------------------------------------
	--  MVPs no so KS
	--------------------------------------------
	local myenemy_type = 0

	if HomunType ~= nil then
		myenemy_type = GetV(V_HOMUNTYPE, id)
	else
		myenemy_type = GetTypeFromID(id)
	end
	
	if MVP_KS_OK[myenemy_type] ~= nil then
		return false
	end	
	--------------------------------------------
	if GetV(V_TARGET, OwnerID) == id then
		return false
	end
	
	for i, v in pairs (Friends) do
		if GetV(V_TARGET, i) == id then
			return false
		end
	end

	local temp_bool = false
	local target_id = GetV(V_TARGET, id)
	if target_id > 0 then
		if (GetV(V_POSITION, target_id) == -1) then
			return false
		end
		local target_id_type = 0
		if HomunType ~= nil then
			target_id_type = GetV(V_HOMUNTYPE, id)
		else
			target_id_type = GetTypeFromID(id)
		end
		local friend = 0
		if Friends[GetV(V_TARGET, id)] ~= nil then
			friend = GetV(V_TARGET, id)
		end
		if (target_id == MyID) or (target_id == OwnerID) or (Friends[target_id] ~= nil) then
			return false
		elseif (IsMonster(target_id) == 1 and (target_id_type < 2114 or target_id_type > 2125)) then
			temp_bool = false
		else
			-- Log("ao de ataque foi abortada (anti-KS): o jogador "..target_id.." j est sendo atacado por "..id..".")
			return true
		end
	end
	
	for i, v in ipairs(Screen_Actors) do
		if (v ~= OwnerID) and (v ~= MyID) then
			if 0 == IsMonster(v) then
				if Friends[v] == nil then
					if GetV(V_TARGET, v) == id or AreaSkill(id, v) then
						-- Log("ao de ataque foi abortada (anti-KS): o jogador "..target_id.." j est atacando "..id..".")
						return true
					end
				end
			end
		end
	end
	if GetV(V_MOTION, id) == MOTION_HIT and NoOneIsTargeting(id) then
		return true
	end
	return temp_bool
end
---------------------------------------------------------------------------
function CountEnemiesCloseTo(id)
---------------------------------------------------------------------------
	local ecount = 0
	
	for i, v in ipairs(Screen_Actors) do
		if v > 0 and 1 == IsMonster(v) then
			if (GetDistance2(id, v) >= 0) and (MOTION_DEAD ~= GetV(V_MOTION, v)) and GetV(V_TARGET, v) == id then
				ecount = ecount + 1
			end
		end
	end
	return ecount
end
---------------------------------------------------------------------------
function ShouldChangeToTargetOf(id, enemy)
---------------------------------------------------------------------------
	if id    == 0 then
		return false
	end
	-----------------------------
	if enemy <= 0 then
		return true
	end
	-----------------------------
	if IsMonster(enemy) == 0 then
		return true
	end
	-----------------------------
	if math.random(1, 100) <= 1 then
		return true
	end
	-----------------------------
	if GetV(V_MOTION, id)      == MOTION_MOVE or  GetV(V_MOTION, id) == MOTION_SIT then
		return true
	end
	-----------------------------
	if id == OwnerID then
		if (GetV(V_HP, id) / GetV(V_MAXHP, id)) * 100 > (GetV(V_HP, MyID) / GetV(V_MAXHP, MyID)) * 100 then
			return false
		end
		if (GetV(V_HP, id) / GetV(V_MAXHP, id)) * 100 < 95 then
			return true
		end
	end
	-----------------------------
	if CountEnemiesCloseTo(MyID) >  CountEnemiesCloseTo(id) then
		return false
	end
	-----------------------------
	if CountEnemiesCloseTo(id)   >= CountEnemiesCloseTo(MyID) then
		return true
	end
	-----------------------------
	if CountEnemiesCloseTo(id)   >  1 then
		return true
	end
	-----------------------------
	if Friends[id] ~= nil                     and GetV(V_MOTION, id) == MOTION_HIT then
		return true
	end
	-----------------------------
	return false
end
---------------------------------------------------------------------------
function IsValidSkillTarget(id, skill)
---------------------------------------------------------------------------
	local myenemy_type = 0
	if HomunType ~= nil then
		myenemy_type = GetV(V_HOMUNTYPE, id)
	else
		myenemy_type = GetTypeFromID(id)
	end
	if myenemy_type == 1288 --  Emperium
	or myenemy_type == 1914 --  Cristal Azul       (Campal)
	or myenemy_type == 1915 --  Cristal Rosa       (Campal)
	or myenemy_type == 1909 --  Armazm de Comida  (Campal)
	or myenemy_type == 1910 --  Depsito de Comida (Campal)
	or myenemy_type == 1911 --  Bandeira Neutra    (Campal)
	or myenemy_type == 1912 --  Bandeira Guillaume (Campal)
	or myenemy_type == 1913 --  Bandeira Croix     (Campal)
	then
		return false
	end
	if skill ~= nil then
		if skill == 8009 and myenemy_type >= 1078 and myenemy_type <= 1085 then
			return false
		end
	end
	return true
end
---------------------------------------------------------------------------
function GetActorAttacking(id)
---------------------------------------------------------------------------
	for i, v in ipairs(Screen_Actors) do
		if GetV(V_TARGET, v) == id and v > 0 then
			if (   GetV(V_MOTION, v)  == MOTION_ATTACK
			   or  GetV(V_MOTION, v)  == MOTION_ATTACK2)
			   and GetV(V_MOTION, id) == MOTION_HIT
			then
				return v
			end
		end
	end
	return 0
end
---------------------------------------------------------------------------
LastSaveChk = 0
------------------------------------------
function SaveTypes(force)	
---------------------------------------------------------------------------
	local time_now = GetTick()
	local delta    = time_now - LastSaveChk
	if LastSaveChk == 0 then 
		LastSaveChk = time_now 
	elseif (delta < 10000) and not force then 
		return
	end
	LastSaveChk = time_now

	local id, id_motion
	--------------------------------
	local actors = Screen_Actors
	local upd_id = {}
	--------------------------------
	local needtoupdate     = false
	local needtoclean      = false
	local remove           = {}
	--------------------------------
	for i, v in ipairs(actors) do
		if (IsMonster(v) == 1 and v > 0) then
			id        = GetV(V_HOMUNTYPE, v)
			id_motion = GetV(V_MOTION, v)
			if       (IDType[v] == nil) and (id_motion ~= MOTION_DEAD) then     --  'Type' novo.
				Log("adicionado monstro para database do Assistente: IDTypes["..v.."] = "..id..".")
				IDType[v] = id
				upd_id[v] = id
				needtoupdate = true
			elseif   (IDType[v] ~= id ) and (id_motion ~= MOTION_DEAD) then     --  'Type' alterado.
				Log("...")
				Log("-------------------------------------------------------------------------------")
				Log("monstro da database do Assistente foi modificado.")
				Log("passou de IDTypes["..v.."] = "..IDType[v].." para IDTypes["..v.."] = "..id..".")
				Log("-------------------------------------------------------------------------------")
				IDType[v] = id
				remove[v] = id
				needtoclean  = true
			end
		end
	end 

	local file_temp = io.open("AI/USER_AI/TEMP/TypeUpdate.txt", "a+")
	if not file_temp then 
		file_temp = io.open("AI/USER_AI/TEMP/TypeUpdate.txt", "w")
		if not file_temp then 
			Log("Falha ao abrir o arquivo 'TEMP/TypeUpdate.txt'.")
			return
		end
	end
    
	local file_main = io.open("AI/USER_AI/ID DATA/Types.lua", "a+")
	if not file_main then 
		Log("Falha ao abrir o arquivo 'ID DATA/Types.lua'.")
		file_temp:close()
		return
	end

	for k, v in pairs(upd_id) do
		file_temp:write(k.." = "..v.."\n")
		if (k >= 50000) then file_main:write("IDType["..k.."] = "..v.."\n") end
	end
	file_temp:close()
	file_main:close()
	
	if needtoclean then
		local file_clean = io.open("AI/USER_AI/ID DATA/Types.lua")
		if file_clean then 
			local list_rewrite = {}
			for l in file_clean:lines() do
				local equal  = string.find(l, "=")
				local temp_k = tonumber(string.sub(l, 8, equal - 3))
				local temp_v = tonumber(string.sub(l, equal + 2))
				if temp_k ~= nil and temp_v ~= nil then
					list_rewrite[temp_k] = temp_v
					if list_rewrite[temp_k] == remove[temp_k] then
						Log("removido IDTypes["..temp_k.."] = "..remove[temp_k]..".")
						list_rewrite[temp_k] = nil
					end
				end
			end
			file_clean:close() 
			file_main = io.open("AI/USER_AI/ID DATA/Types.lua", "w")
			if file_main then 
				file_main:write("IDType = {}\n")
				for k, v in pairs(list_rewrite) do
					if (k >= 50000) then file_main:write("IDType["..k.."] = "..v.."\n") end
				end
				file_main:close()
			end
		end
		Log("limpeza do arquivo 'ID DATA/Types.lua'.")
	end
	return
end
---------------------------------------------------------------------------
function GetTypeFromID(id)
---------------------------------------------------------------------------
	if IDType[id] == nil then
		return 0
	else
		return IDType[id]
	end
end 
---------------------------------------------------------------------------
LastUpdChk = 0
------------------------------------------
function LoadTypes(force)	
---------------------------------------------------------------------------
	local time_now = GetTick()
	local delta    = time_now - LastUpdChk
	if LastUpdChk == 0 then 
		LastUpdChk = time_now 
	elseif (delta < 5000) and not force then 
		return
	end
	LastUpdChk = time_now

	local file = io.open("AI/USER_AI/TEMP/TypeUpdate.txt")
	if not file then return end
	
	for l in file:lines() do
		local equal  = string.find(l, "=")
		local temp_k = tonumber(string.sub(l, 1, equal - 2))
		local temp_v = tonumber(string.sub(l, equal + 2))
		if temp_k == nil or temp_v == nil then
			Log("No  possvel processar a linha: "..l.." de TypeUpdate.txt.")
		else
			IDType[temp_k] = temp_v
		end
	end
	file:close()
	if FileExists("AI/USER_AI/TEMP/TypeUpdate.txt") then
		os.remove("AI/USER_AI/TEMP/TypeUpdate.txt")
	end	
	return
end 
---------------------------------------------------------------------------
function FileExists(path)
---------------------------------------------------------------------------
	local file = io.open(path, "rb")
	if file then file:close() end
	return file ~= nil
end
-- =======================================
--  Salvar Tticas
-- =======================================
---------------------------------------------------------------------------
SkillToType = {}
-----------------
SkillToType_File = "AI/USER_AI/ID DATA/SkillToType_H.txt"
------------------------------------------
Ally_AI = 1
------------------------------------------
function SaveSkillToType(level, skill, id)
---------------------------------------------------------------------------
	if id == nil then
		return
	end
	if id <= 0 then
		return
	end
	if HomunType ~= nil then
		local ln, nbr
		local f_out = io.open(SkillToType_File, "a+")
		if f_out == nil then
			local f_out = io.open(SkillToType_File, "w")
		end
		if SkillToType[GetV(V_HOMUNTYPE, id)] ~= nil then
			SkillToType[GetV(V_HOMUNTYPE, id)] = nil
			if f_out ~= nil then
				f_out:close()
				os.remove(SkillToType_File)
				f_out = io.open(SkillToType_File, "w")
				if f_out ~= nil then
					for i, v in pairs(SkillToType) do
						if i > 0 then
							f_out:write(i..","..v.Skill..","..v.Level.."\n")
						end
					end
					f_out:close()
				end
			else
				Log("no foi possvel abrir o arquivo de Habilidades por Tipo (\"ID DATA/SkillToType_H.txt\").")
			end
		else
			SkillToType[GetV(V_HOMUNTYPE, id)] = {Skill = skill, Level = level}
			if f_out ~= nil then
				f_out:write(GetV(V_HOMUNTYPE, id)..","..skill..","..level.."\n")
				f_out:close()
			else
				Log("no foi possvel abrir o arquivo de Habilidades por Tipo (\"ID DATA/SkillToType_H.txt\").")
			end
		end
	end
end
---------------------------------------------------------------------------
function LoadSkillToType()
---------------------------------------------------------------------------
	Log("Carregando Habilidades por Tipo...")
	local error = false
	if HomunType ~= nil then
		local ln, nbr1, nbr2, nbr3
		local find_result, lstfind_result
		local f_in = io.open(SkillToType_File, "r")
		if f_in ~= nil then
			ln = f_in:read()
			while ln ~= nil do
				find_result = string.find(ln, ",")
				if find_result ~= nil then
					nbr1 = tonumber(string.sub(ln, 1, find_result - 1))
					if nbr1 ~= nil then
						--Log("nbr1 = "..nbr1..".")
					else
						Log("erro (nbr1).")
						error = true
					end
					lstfind_result = find_result + 1
				end
				if find_result == nil then
					Log("erro.")
					error = true
					break
				end
				find_result = string.find(ln, ",", lstfind_result)
				if find_result ~= nil then
					nbr2 = tonumber(string.sub(ln, lstfind_result, find_result - 1))
					if nbr2 ~= nil then
						--Log("nbr2 = "..nbr2..".")
					else
						Log("erro (nbr2).")
						error = true	
					end
					lstfind_result = find_result + 1
				end
				if find_result == nil then
					Log("erro.")
					error = true
					break
				end
				nbr3 = tonumber(string.sub(ln, lstfind_result))
				if nbr3 ~= nil then
					--Log("nbr3 = "..nbr3..".")
				else
					Log("erro (nbr3).")
					error = true	
				end
				if nbr1 ~= nil and nbr2 ~= nil and nbr3 ~= nil then
					Log("Habilidade Definida: SkillToType["..nbr1.."] = {Skill = "..nbr2..", Level = "..nbr3.."}.")
					SkillToType[nbr1] = {Skill = nbr2, Level = nbr3}
				end
				ln = f_in:read()
			end
			f_in:close()
			if error then
				if FileExists(SkillToType_File) then
					os.remove(SkillToType_File)
				end
			end
		end
	end
end
---------------------------------------------------------------------------
Behav = {}
-----------------
Behav_Files     = {}
Behav_Files[1] = "AI/USER_AI/ID DATA/AggroMob_H.txt"
Behav_Files[2] = "AI/USER_AI/ID DATA/AggroMob_A.txt"
-----------------
function SaveBehavToID_or_Type(id, behav)
---------------------------------------------------------------------------
	if id == nil then
		return
	end
	if id <= 0 then
		return
	end
	local ai_type, ln, nbr
	if HomunType ~= nil then ai_type = 1 else ai_type = 2 end	
	local f_out = io.open(Behav_Files[ai_type], "a+")
	if f_out == nil then
		local f_out = io.open(Behav_Files[ai_type], "w")
	end
	if f_out ~= nil then
		if     behav == "Aggressive" then
			AggroHP = AggroHP - 10
			if     AggroHP > 100 then
				AggroHP = 100
			elseif AggroHP < 0   then
				AggroHP = 0
			end
			ClearBehavID(id)
			Log("salvar (1) AggroHP = "..AggroHP..".")
		elseif behav == "Defensive" then
			AggroHP = AggroHP + 10
			if     AggroHP > 100 then
				AggroHP = 100
			elseif AggroHP < 0   then
				AggroHP = 0
			end
			ClearBehavID(id)
			Log("salvar (2) AggroHP = "..AggroHP..".")
		else
			AggroHP = 95
			ClearBehavID(id)
			Log("salvar (3) AggroHP = "..AggroHP..".")
		end
		if IsPlayer(id) then
			if Behav[id] ~= nil then
				Behav[id] = behav
				ClearBehavID(id)
			else
				Behav[id] = behav
				f_out:write(id..","..behav.."\n")
			end
		else
			local type
			if HomunType ~= nil then
				type = GetV(V_HOMUNTYPE, id)
			else
				type = GetTypeFromID(id)
			end
			if Behav[type] ~= nil then
				Behav[type] = behav
				ClearBehavID(type)
			else
				Behav[type] = behav
				f_out:write(type..","..behav.."\n")
			end
		end
		f_out:close()
	end
end
---------------------------------------------------------------------------
function LoadBehavToID_or_Type()
---------------------------------------------------------------------------
	Log("Carregando Comportamentos Salvos.")
	local error = false
	local ln, nbr1, behav
	local find_result, lstfind_result
	local ai_type
	if HomunType ~= nil then ai_type = 1 else ai_type = 2 end	
	local f_in = io.open(Behav_Files[ai_type], "r")
	if f_in ~= nil then
		ln = f_in:read()
		nbr1 = tonumber(ln)
		if nbr1 ~= nil then
			--Log("nbr1 = "..nbr1..".")
		else
			Log("erro (nbr1, para AggroHP).")
			error = true
		end
		if nbr1 ~= nil then
			Log("HP para Agressividade Definido: AggroHP = "..nbr1..".")
			AggroHP = nbr1
		end
		ln = f_in:read()
		while ln ~= nil do
			if error == true then
				break
			end
			find_result = string.find(ln, ",")
			if find_result ~= nil then
				nbr1 = tonumber(string.sub(ln, 1, find_result - 1))
				if nbr1 ~= nil then
					--Log("nbr1 = "..nbr1..".")
				else
					Log("erro (nbr1).")
					error = true
				end
				lstfind_result = find_result + 1
			end
			if find_result == nil then
				Log("erro.")
				error = true
				break
			end
			behav = string.sub(ln, lstfind_result)
			if behav ~= nil then
				--Log("behav = "..behav..".")
			else
				Log("erro (behav).")	
				error = true
			end
			if nbr1 ~= nil and behav ~= nil then
				Log("Comportamento Definido: Behav["..nbr1.."] = \""..behav.."\".")
				Behav[nbr1] = behav
			end
			ln = f_in:read()
		end
		f_in:close()
		if error then
			if FileExists(Behav_Files[ai_type]) then
				os.remove(Behav_Files[ai_type])
			end
		end
	end
end
---------------------------------------------------------------------------
function ClearBehavID(id)
---------------------------------------------------------------------------
	local ai_type, ln, nbr
	if HomunType ~= nil then ai_type = 1 else ai_type = 2 end
	os.remove(Behav_Files[ai_type])
	local f_out = io.open(Behav_Files[ai_type], "w")
	if f_out ~= nil then
		f_out:write(AggroHP.."\n")
		for i, v in pairs(Behav) do
			if i > 0 then
				f_out:write(i..","..v.."\n")
			end
		end
		f_out:close()
	end
end
---------------------------------------------------------------------------
function GetBehavToID_or_Type(id)
---------------------------------------------------------------------------
	local result = "Defensive"
		if IsPlayer(id) then
			result = Behav[id]
		else
			local type
			if HomunType ~= nil then
				type = GetV(V_HOMUNTYPE, id)
			else
				type = GetTypeFromID(id)
			end
			result = Behav[type]
		end
	return result
end
-- =======================================
--  Movimentao
-- =======================================
---------------------------------------------------------------------------
function ShouldFollow()
---------------------------------------------------------------------------
	if GetDistance(MyDestX, MyDestY, OwnerX, OwnerY) > 6 and MyState == FOLLOW_ST then
		if (MyDestX > OwnerX and X_Mark == 1)
		or (MyDestX < OwnerX and X_Mark == -1)
		or (MyDestX == OwnerX and X_Mark == 0) then
			return false
		elseif (MyDestY > OwnerY and Y_Mark == 1)
		or (MyDestY < OwnerY and Y_Mark == -1)
		or (MyDestY == OwnerY and Y_Mark == 0) then
			return false
		end
	end
	if NearerOrFarther == -1 then
		return false
	end
	local distance = GetDistanceFromOwner(MyID)
	if MyState == FOLLOW_ST then
		if (GetV(V_MOTION, OwnerID) ~= MOTION_MOVE and not OwnerPosChanged and distance <= MaxDistance - 8) then
			return false
		end
	end
	if (MyEnemy > 0 and (GetV(V_MOTION, OwnerID) == MOTION_MOVE or OwnerPosChanged) and NearerOrFarther == 1 and (GetDistance2(MyID, OwnerID) > 3 or GetV(V_MOTION, MyID) == MOTION_MOVE)) then
		return true
	elseif  (distance > MaxDistance - 3 and MyState == IDLE_ST) or (distance > 4 and (GetV(V_MOTION, OwnerID) == MOTION_MOVE or OwnerPosChanged) and NearerOrFarther == 1) then
		return true
	elseif  (GetV(V_MOTION, OwnerID) == MOTION_MOVE or OwnerPosChanged or distance > 4) and MyState == FOLLOW_ST then
		return true
	end
	return false
end
---------------------------------------------------------------------------
function BestMovementToOwner() --  01/07/2011: implantao de sistema para homnculo se mover  frente; 02/07/2011: correes; 09/07/2011: no ficar  frente se tiver um inimigo;
                               -- 12/07/2011: ajustes para o homnculo / assistente no ficar para trs... 27/07/2011: mais ajustes!
---------------------------------------------------------------------------
	local X = OwnerX
	local Y = OwnerY 
	-------------------------------------------
	local distance_X = (math.abs(MyX - X))
	local distance_Y = (math.abs(MyY - Y))
	------------------------------------------- 
	if GetV(V_MOTION, OwnerID) == MOTION_MOVE and MyState == FOLLOW_ST and BlockDistance2(MyID, OwnerID) <= MaxDistance - 9 then
		if X_Mark == -1 then
			if (MyX <= X) or (BlockDistance2(MyID, OwnerID) <= 3) then
				X = MyX - (4)
			end
		elseif X_Mark == 1 then
			if (MyX >= X) or (BlockDistance2(MyID, OwnerID) <= 3) then
				X = MyX + (4)
			end
		else
			if     (MyX < X - 3) then
				if GetV(V_MOTION, MyID) == MOTION_MOVE then
					X = X + math.random(0, 3)
				end
			elseif (MyX > X + 3) then
				if GetV(V_MOTION, MyID) == MOTION_MOVE then
					X = X - math.random(0, 3)
				end
			end
		end

		if Y_Mark == -1 then
			if (MyY <= Y) or (BlockDistance2(MyID, OwnerID) <= 3) then
				Y = MyY - (4)
			end
		elseif Y_Mark == 1 then 
			if (MyY >= Y) or (BlockDistance2(MyID, OwnerID) <= 3) then
				Y = MyY + (4)
			end
		else
			if     (MyY < Y - 3) then
				if GetV(V_MOTION, MyID) == MOTION_MOVE then
					Y = Y + math.random(0, 3)
				end
			elseif (MyY > Y + 3) then
				if GetV(V_MOTION, MyID) == MOTION_MOVE then
					Y = Y - math.random(0, 3)
				end
			end
		end
	elseif GetV(V_MOTION, OwnerID) ~= MOTION_MOVE then
		if     (MyX < X) then
			if BlockDistance2(MyID, OwnerID) > 3 then
				X = X - math.random((distance_X - 5), (distance_X - 4))
			else
				X = X - math.random(0, 3)
			end
		elseif (MyX > X) then
			if BlockDistance2(MyID, OwnerID) > 3 then
				X = X + math.random((distance_X - 5), (distance_X - 4))
			else
				X = X + math.random(0, 3)
			end
		end
	
		if     (MyY < Y) then
			if BlockDistance2(MyID, OwnerID) > 3 then
				Y = Y - math.random((distance_Y - 5), (distance_Y - 4))
			else
				Y = Y - math.random(0, 3)
			end
		elseif (MyY > Y) then
			if BlockDistance2(MyID, OwnerID) > 3 then
				Y = Y + math.random((distance_Y - 5), (distance_Y - 4))
			else
				Y = Y + math.random(0, 3)
			end
		end
		--  Anti-Lag... Se est dentro da mesma rea anterior, no mude o destino.
		if (math.abs(X - MyDestX)) <= (math.abs(MyX - X)) and (math.abs(Y - MyDestY)) <= (math.abs(MyY - Y)) then
			X, Y = OwnerX, OwnerY
		end
	else
		if     (MyX < X - 3) then
			if GetV(V_MOTION, MyID) == MOTION_MOVE then
				X = X + math.random(0, 3)
			end
		elseif (MyX > X + 3) then
			if GetV(V_MOTION, MyID) == MOTION_MOVE then
				X = X - math.random(0, 3)
			end
		end

		if     (MyY < Y - 3) then
			if GetV(V_MOTION, MyID) == MOTION_MOVE then
				Y = Y + math.random(0, 3)
			end
		elseif (MyY > Y + 3) then
			if GetV(V_MOTION, MyID) == MOTION_MOVE then
				Y = Y - math.random(0, 3)
			end
		end
	end
	return X, Y
end
---------------------------------------------------------------------------
function BestMovementTo(id)
---------------------------------------------------------------------------
	local x, y = GetV(V_POSITION, id)
	if x == -1 then
		return MyX, MyY
	end
	local anyoneCouldMove = false
	for i, v in pairs (Screen_Actors) do
		if GetV(V_MOTION, v) == MOTION_MOVE then
			anyoneCouldMove = true
			break
		end
	end
	local X
	if (x < MyX) then
		if anyoneCouldMove then
			X = x + math.random(-AttackRange, AttackRange)
		else
			X = x + 1
		end
	elseif (x > MyX) then
		if anyoneCouldMove then
			X = x - math.random(-AttackRange, AttackRange)
		else
			X = x - 1
		end
	elseif (x == MyX) then
		X = x
	end
	
	local Y
	if (y < MyY) then
		if anyoneCouldMove then
			Y = y + math.random(-AttackRange, AttackRange)
		else
			Y = y + 1
		end
	elseif (y > MyY) then
		if anyoneCouldMove then
			Y = y - math.random(-AttackRange, AttackRange)
		else
			Y = y - 1
		end
	elseif (y == MyY) then
		Y = y
	end
	if GetDistance(X, Y, OwnerX, OwnerY) < MaxDistance then
		return X, Y
	end
	return x, y
end
---------------------------------------------------------------------------
function RemoveBugMovement(id)
---------------------------------------------------------------------------
	local x, y
	if id == nil then
		x, y = GetV(V_POSITION, MyEnemy)
	else
		x, y = GetV(V_POSITION, id)
	end
	if x == nil then
		x, y = GetV(V_POSITION, MyEnemy)
	end
	if AttackRange > 2 then
		if GetV(V_TARGET, MyEnemy) == OwnerID then
			local X
			if (x < OwnerX) then
				X = OwnerX - 1
			elseif (x > OwnerX) then
				X = OwnerX + 1
			elseif (x == OwnerX) then
				X = OwnerX
			end
			
			local Y
			if (y < OwnerY) then
				Y = OwnerY - 1
			elseif (y > OwnerY) then
				Y = OwnerY + 1
			elseif (y == OwnerY) then
				Y = OwnerY
			end
			if GetDistance(X, Y, OwnerX, OwnerY) < MaxDistance then
				return X, Y
			end
		else
			local x2, y2 = GetV(V_POSITION, GetV(V_TARGET, MyEnemy))
			if x2 == -1 then
				if GetDistance2(MyID, MyEnemy) <= 4 then
					return OwnerX, OwnerY
				else
					return x, y
				end
			end
			local X
			if (x < x2) then
				X = x2 - 1
			elseif (x > x2) then
				X = x2 + 1
			elseif (x == x2) then
				X = x2
			end
			
			local Y
			if (y < y2) then
				Y = y2 - 1
			elseif (y > y2) then
				Y = y2 + 1
			elseif (y == y2) then
				Y = y2
			end
			if GetDistance(X, Y, OwnerX, OwnerY) < MaxDistance then
				return X, Y
			end
		end
	else
		if GetV(V_TARGET, MyEnemy) == OwnerID then
			if GetDistance2(MyEnemy, OwnerID) <= 2 then
				local X
				if (x < OwnerX) then
					X = OwnerX - 1
				elseif (x > OwnerX) then
					X = OwnerX + 1
				elseif (x == OwnerX) then
					X = OwnerX
				end
			
				local Y
				if (y < OwnerY) then
					Y = OwnerY - 1
				elseif (y > OwnerY) then
					Y = OwnerY + 1
				elseif (y == OwnerY) then
					Y = OwnerY
				end
				if GetDistance(X, Y, OwnerX, OwnerY) < MaxDistance then
					return X, Y
				end
			else
				local X
				if (x < OwnerX) then
					X = x - 1
				elseif (x > OwnerX) then
					X = x + 1
				elseif (x == OwnerX) then
					X = x
				end
			
				local Y
				if (y < OwnerY) then
					Y = y - 1
				elseif (y > OwnerY) then
					Y = y + 1
				elseif (y == OwnerY) then
					Y = y
				end
				if GetDistance(X, Y, OwnerX, OwnerY) < MaxDistance then
					return X, Y
				end
			end
		else
			local X
			if (x < MyX) then
				X = x - 1
			elseif (x > MyX) then
				X = x + 1
			elseif (x == MyX) then
				X = x
			end
			
			local Y
			if (y < MyY) then
				Y = y - 1
			elseif (y > MyY) then
				Y = y + 1
			elseif (y == MyY) then
				Y = y
			end
			if GetDistance(X, Y, OwnerX, OwnerY) < MaxDistance then
				return X, Y
			end
		end
	end
	if GetDistance(x, y, OwnerX, OwnerY) < MaxDistance then
		return x, y
	else
		return MyX, MyY
	end
end
---------------------------------------------------------------------------
function ClearPatrolDests()
---------------------------------------------------------------------------
	UseIdleMovement = false
	PatrolDests_IndexOfUse = 1
	PatrolDests_Index      = 1
	for i, v in pairs(PatrolDests) do
		PatrolDests[i] = nil
	end
	IsPatrol_Time = 0
	IsPatrol      = false
end
---------------------------------------------------------------------------
function SkillsNotEngaged(homunculus)
---------------------------------------------------------------------------
	local result = true
	local verify_previous = false
	if homunculus == "Sera" then
		if Skills_Homun[8018].Engaged or Skills_Homun[8019].Engaged or Skills_Homun[8020].Engaged or Skills_Homun[8021].Engaged then
			result = false
		end
		verify_previous = true
	end
	if homunculus == "Eira" then
		if Skills_Homun[8022].Engaged or Skills_Homun[8023].Engaged or Skills_Homun[8024].Engaged or Skills_Homun[8025].Engaged or Skills_Homun[8026].Engaged then
			result = false
		end
		verify_previous = true
	end
	if homunculus == "Eleanor" then
		if Skills_Homun[8027].Engaged or Skills_Homun[8028].Engaged or Skills_Homun[8029].Engaged or Skills_Homun[8030].Engaged or Skills_Homun[8036].Engaged or Skills_Homun[8037].Engaged or Skills_Homun[8038].Engaged then
			result = false
		end
		verify_previous = true
	end
	if homunculus == "Bayeri" then
		if Skills_Homun[8031].Engaged or Skills_Homun[8032].Engaged or Skills_Homun[8033].Engaged or Skills_Homun[8034].Engaged or Skills_Homun[8035].Engaged then
			result = false
		end
		verify_previous = true
	end
	if homunculus == "Dieter" then
		if Skills_Homun[8039].Engaged or Skills_Homun[8040].Engaged or Skills_Homun[8041].Engaged or Skills_Homun[8042].Engaged or Skills_Homun[8043].Engaged then
			result = false
		end
		verify_previous = true
	end
	---------------------------------------------------------------------------------------
	if homunculus == "Vanilmirth" or verify_previous == true then --
		if Skills_Homun[8013].Engaged or Skills_Homun[8014].Engaged then
			result = false
		end
	end
	if homunculus == "Filir" or verify_previous == true then --
		if Skills_Homun[8009].Engaged or Skills_Homun[8011].Engaged or Skills_Homun[8010].Engaged then
			result = false
		end
	end
	if homunculus == "Lif" or verify_previous == true then --
		if Skills_Homun[8002].Engaged or Skills_Homun[8001].Engaged or Skills_Homun[8004].Engaged then
			result = false
		end
	end
	if homunculus == "Amistr" or verify_previous == true then --
		if Skills_Homun[8006].Engaged or Skills_Homun[8005].Engaged or Skills_Homun[8008].Engaged then
			result = false
		end
	end
	return result
end
-- =======================================
--  Lista de Protegidos
-- =======================================
---------------------------------------------------------------------------
function FriendList_Clear(keepnotplayers)
---------------------------------------------------------------------------
	if keepnotplayers == nil then
		keepnotplayers = false
	end
	local ln, nbr
	if not keepnotplayers then
		for i, v in pairs (Friends) do
			Friends[i] = nil
		end
	end
	local f_in = io.open("AI/USER_AI/TEMP/Friends.txt", "r")
	local f_in_friends = {}
	if f_in ~= nil then
		ln = f_in:read()
		while ln ~= nil do
			nbr = tonumber(ln)
			if nbr ~= nil then
				if IsPlayer(nbr) then
					f_in_friends[nbr] = nbr
				else
					if not keepnotplayers then
						f_in_friends[nbr] = nil
					else
						f_in_friends[nbr] = nbr
					end
				end
			end
			ln = f_in:read()
		end
		f_in:close()
		local f_out = io.open("AI/USER_AI/TEMP/Friends.txt", "w")
		if f_out ~= nil then
			for i, v in pairs (f_in_friends) do
				f_out:write(v.."\n")
			end
			f_out:close()
		else
			Log("no foi possvel abrir a lista de amigos.")
		end
	end
	AddAllyAIToFriends(true)
end
---------------------------------------------------------------------------
function FriendList_Load(keepnotplayers)
---------------------------------------------------------------------------
	if keepnotplayers == nil then
		keepnotplayers = false
	end
	FriendList_Clear(keepnotplayers)
		
	local ln, nbr
	
	local f_in = io.open("AI/USER_AI/TEMP/Friends.txt", "r")
	if f_in ~= nil then
		ln = f_in:read()
		while ln ~= nil do
			nbr = tonumber(ln)
			if nbr ~= nil then
				Friends[nbr] = nbr
			end
			ln = f_in:read()
		end
		f_in:close()
		Log("lista de amigos carregada.")
	else
		Log("o arquivo 'AI/USER_AI/TEMP/Friends.txt' no existe.")
	end
end
---------------------------------------------------------------------------
function FriendList_Save(id)
---------------------------------------------------------------------------
	local ln, nbr
	local f_out = io.open("AI/USER_AI/TEMP/Friends.txt", "a+")
	if f_out ~= nil then
		f_out:write(id.."\n")
		f_out:close()
		Log("amigo satisfatoriamente salvo no arquivo '/Friends.txt'.")
	else
		Log("o arquivo 'AI/USER_AI/TEMP/Friends.txt' no existe.")
	end
end
---------------------------------------------------------------------------
function FriendList_Remove(id)
---------------------------------------------------------------------------
	local ln, nbr
	local f_in = io.open("AI/USER_AI/TEMP/Friends.txt", "r")
	local f_in_friends = {}
	if f_in ~= nil then
		for i, v in pairs (Friends) do
			if TempFriend[v] == nil and v ~= Ally_AI then --  Se for amigo temporrio, apaga, se no for AI aliada, tambm apaga.
				Friends[i] = nil
			end
		end
		ln = f_in:read()
		while ln ~= nil do
			nbr = tonumber(ln)
			if nbr ~= nil then
				f_in_friends[nbr] = nbr
			end
			ln = f_in:read()
		end
		f_in:close()
		f_in_friends[id] = nil
		local f_out = io.open("AI/USER_AI/TEMP/Friends.txt", "w")
		if f_out ~= nil then
			for i, v in pairs (f_in_friends) do
				f_out:write(v.."\n")
				Friends[i] = v
			end
			f_out:close()
			AddAllyAIToFriends(true)
			Log("amigo satisfatoriamente removido do arquivo '/Friends.txt'.")
		end
	else
		Log("o arquivo 'AI/USER_AI/TEMP/Friends.txt' no existe.")
	end
end
---------------------------------------------------------------------------
function FriendList_Switch(id)
---------------------------------------------------------------------------
	if Friends[id] == nil or TempFriend[id] ~= nil then
		FriendList_Save(id)
		TempFriend[id] = nil
		Friends[id] = id
		Log("o amigo "..id.." foi adicionado.")
		return 1
	else
		FriendList_Remove(id)
		Friends[id] = nil
		Log("o amigo "..id.." foi removido.")
		return 2
	end
end
---------------------------------------------------------------------------
LastTFSChk = 0
------------------------------------------
function TempFriendSearch(force)
---------------------------------------------------------------------------
	local time_now = GetTick()
	local delta    = time_now - LastTFSChk

	if LastTFSChk == 0 then 
		LastTFSChk = time_now 
	elseif (delta < 1000) and not force then 
		return false
	end
	LastTFSChk = time_now
	
	for i, v in pairs (TempFriend) do
		if (GetDistance2(v, OwnerID) > 2
		and GetV(V_MOTION, v) ~= MOTION_SIT 
		and GetV(V_MOTION, v) ~= MOTION_STAND 
		and GetV(V_MOTION, v) ~= MOTION_HIT
		and GetV(V_MOTION, v) ~= MOTION_SKILL)
		or MyState == FOLLOW_CMD_ST or IsOutOfSight(MyID, v)
		or PvPHere
		then
			Log(i.." saiu de perto do Dono: no est mais protegido.")
			TempFriend[i] = nil
			Friends[i]    = nil
		elseif TempFriend[i] ~= nil and Friends[i] == nil then --  Filtragem para ser protegido quando for amigo temporrio...
			Friends[i]    = v
		end
	end
	local file_tempfriend = io.open("AI/USER_AI/ID DATA/TempFriends_No.txt", "r")
	if file_tempfriend then
		file_tempfriend:close()
		return false
	end
	local result = false
	for i, v in ipairs(Screen_Actors) do
		if GetDistance2(v, OwnerID) <= 2 then
			if v > 0 and v ~= MyID and v ~= OwnerID and Friends[v] == nil and not PvPHere then
				if  GetV(V_MOTION, v) == MOTION_SIT then
					TempFriend[v] = v
					Friends[v]    = v
					if not result then
						result = true
					end
					Log(v.." sentou prx. ao Dono: marcar como amigo temporrio at se mover a uma distncia maior que 2 'quadrados'.")
				end
			end
		end
	end
	return result
end
---------------------------------------------------------------------------
LastAllyChk = 0
------------------------------------------
ID_Files = {}
ID_Files[1] = "AI/USER_AI/TEMP/ID_A.txt"
ID_Files[2] = "AI/USER_AI/TEMP/ID_H.txt"
------------------------------------------
Ally_AI = 1
------------------------------------------
function AddAllyAIToFriends(force)
---------------------------------------------------------------------------
	local time_now = GetTick()
	local delta    = time_now - LastAllyChk

	if LastAllyChk == 0 then 
		LastAllyChk = time_now 
	elseif (delta < 10000) and not force then 
		return false
	end
	LastAllyChk = time_now
	
	if not force then
		local ln, nbr
		local f_in = io.open("AI/USER_AI/TEMP/Friends.txt", "r")
		local f_in_friends = {}
		if Ally_AI ~= 1 then
			f_in_friends[Ally_AI] = Ally_AI
		end
		if f_in ~= nil then
			for i, v in pairs (Friends) do
				Friends[i] = nil
			end
			ln = f_in:read()
			while ln ~= nil do
				nbr = tonumber(ln)
				if nbr ~= nil then
					f_in_friends[nbr] = nbr
				end
				ln = f_in:read()
			end
			f_in:close()
			for i, v in pairs (f_in_friends) do
				Friends[i] = v
			end
		end
	end
	if Initialized then
		local savemyid
		if     HomunType ~= nil then
			savemyid = io.open("AI/USER_AI/TEMP/ID_H.txt", "a+")
			if savemyid == nil then
				savemyid = io.open("AI/USER_AI/TEMP/ID_H.txt", "w")
			end
		elseif MercType ~= nil then
			savemyid = io.open("AI/USER_AI/TEMP/ID_A.txt", "a+")
			if savemyid == nil then
				savemyid = io.open("AI/USER_AI/TEMP/ID_A.txt", "w")
			end
		end
		if savemyid ~= nil then
			local line = savemyid:read()
			local number, number2
			number = 0
			number2 = 0
			while line ~= nil do
				number = tonumber(line)
				if number ~= nil then
					if number == MyID then
						line = savemyid:read()
						number2 = tonumber(line)
						if number2 == OwnerID then
							break
						else
							number = 0
						end
					end
				end
				line = savemyid:read()
			end
			if number ~= MyID then
				savemyid:write(MyID.."\n"..OwnerID.."\n")
			end
			savemyid:close()
		end
	end
	-- Log("procurando por AI aliada para adicionar aos amigos.")
	
	local f_in, ln, nbr, nbr2, ally_ai
	nbr = 0
	nbr2 = 0
	local allyIsHere = false
	
	if HomunType == nil then ally_ai = 2 else ally_ai = 1 end
		
	f_in = io.open(ID_Files[ally_ai], "r") 
	if f_in then
		ln = f_in:read()
		while ln ~= nil do
			nbr = tonumber(ln)
			if nbr ~= nil then
				ln = f_in:read()
				if ln ~= nil then
					nbr2 = tonumber(ln)
					if nbr2 ~= nil then
						if nbr2 == OwnerID then
							allyIsHere = true
							break
						end
					end
				end
			end
			ln = f_in:read()
		end
		f_in:close()
		if allyIsHere then
			if (Ally_AI == 1 or GetV(V_POSITION, Ally_AI) == -1 or GetV(V_POSITION, Ally_AI) == nil) then
				if nbr > 0 then
					if GetV(V_POSITION, nbr) ~= -1 and GetV(V_POSITION, nbr) ~= nil and not IsOutOfSight(MyID, nbr)  then
						Ally_AI = nbr
						Friends[Ally_AI] = Ally_AI
						Log("o ID "..Ally_AI.." foi detectado como AI aliada e adicionado aos amigos.")
						return true
					else
						Log("AI aliada fora do alcance ou seu tempo expirou: removendo ID dos amigos.")
						if FileExists(ID_Files[ally_ai]) then
							os.remove(ID_Files[ally_ai])
						end
						-------
						if     MercType ~= nil  then
							if FileExists("AI/USER_AI/ID DATA/LowHP_H.txt") then
								os.remove("AI/USER_AI/ID DATA/LowHP_H.txt")
							end
						-------
						elseif HomunType ~= nil then
							if FileExists("AI/USER_AI/ID DATA/LowHP_A.txt") then
								os.remove("AI/USER_AI/ID DATA/LowHP_A.txt")
							end
						end
						Friends[Ally_AI] = nil
						Ally_AI = 1
						return false
					end
				end
			end
		end
	else
		-------
		if     MercType ~= nil  then
			if FileExists("AI/USER_AI/ID DATA/LowHP_H.txt") then
				os.remove("AI/USER_AI/ID DATA/LowHP_H.txt")
			end
		-------
		elseif HomunType ~= nil then
			if FileExists("AI/USER_AI/ID DATA/LowHP_A.txt") then
				os.remove("AI/USER_AI/ID DATA/LowHP_A.txt")
			end
		end
		-- Log("arquivo com a ID de AI aliada no pde ser aberto.")
		Friends[Ally_AI] = nil
		Ally_AI = 1
		return false
	end
	return false
end
-- ================================================
--  Utilidades de Listagem (para as funes padro)
-- ================================================
---------------------------------------------------------------------------
List = {}
------------------------------------------
function List.new()
---------------------------------------------------------------------------
	return {first = 0, last = -1}
end
---------------------------------------------------------------------------
function List.pushleft(list, value)
---------------------------------------------------------------------------
	local first = list.first - 1
	list.first  = first
	list[first] = value;
end
---------------------------------------------------------------------------
function List.pushright(list, value)
---------------------------------------------------------------------------
	local last = list.last + 1
	list.last  = last
	list[last] = value
end
---------------------------------------------------------------------------
function List.popleft(list)
---------------------------------------------------------------------------
	local first = list.first
	if first > list.last then 
		return nil
	end
	local value = list[first]
	list[first] = nil         --  to allow garbage collection.
	list.first  = first + 1
	return value
end
---------------------------------------------------------------------------
function List.popright(list)
---------------------------------------------------------------------------
	local last = list.last
	if list.first > last then
		return nil
	end
	local value = list[last]
	list[last]  = nil
	list.last   = last - 1
	return value 
end
---------------------------------------------------------------------------
function List.clear(list)
	for i, v in ipairs(list) do
		list[i] = nil
	end
--[[
	if List.size(list) == 0 then
		return
	end
	local first = list.first
	local last  = list.last
	for i = first, last do
		list[i] = nil
	end
--]]
	list.first = 0
	list.last  = -1
end
---------------------------------------------------------------------------
function List.size(list)
	local size = list.last - list.first + 1
	return size
end
-- =======================================
--  Funes de Posicionamento Padro
-- =======================================
---------------------------------------------------------------------------
function GetDistance(x1, y1, x2, y2)
---------------------------------------------------------------------------
	if (x1 == nil or x2 == nil or y1 == nil or y2 == nil) then
		return -1
	end
	return math.floor(math.sqrt((x1 - x2) ^ 2 + (y1 - y2) ^ 2))
end
---------------------------------------------------------------------------
function GetDistance2(id1, id2)
---------------------------------------------------------------------------
	if (id1 == nil or id2 == nil) then
		return -1
	end
	local x1, y1 = GetV(V_POSITION, id1)
	if     id1 == OwnerID then
		x1, y1 = OwnerX, OwnerY
	elseif id1 == MyID    then
		x1, y1 = MyX, MyY
	end
	local x2, y2 = GetV(V_POSITION, id2)
	if     id2 == OwnerID then
		x2, y2 = OwnerX, OwnerY
	elseif id2 == MyID    then
		x2, y2 = MyX, MyY
	end
	if (x1 == -1 or x2 == -1) then
		return -1
	end
	return GetDistance(x1, y1, x2, y2)
end
---------------------------------------------------------------------------
function GetOwnerPosition(id)
---------------------------------------------------------------------------
	if OwnerX ~= nil then
		return OwnerX, OwnerY
	else
		return GetV(V_POSITION, GetV(V_OWNER, id))
	end
end
---------------------------------------------------------------------------
function BlockDistance(x1, y1, x2, y2)
---------------------------------------------------------------------------
	local x_delta = math.abs(x2 - x1)
	local y_delta = math.abs(y2 - y1)

	if x_delta > y_delta then
		return x_delta
	end

	return y_delta
end
---------------------------------------------------------------------------
function BlockDistance2(id1, id2)
---------------------------------------------------------------------------
	local x1, y1 = GetV(V_POSITION, id1)
	if     id1 == OwnerID then
		x1, y1 = OwnerX, OwnerY
	elseif id1 == MyID    then
		x1, y1 = MyX, MyY
	end
	local x2, y2 = GetV(V_POSITION, id2)
	if     id2 == OwnerID then
		x2, y2 = OwnerX, OwnerY
	elseif id2 == MyID    then
		x2, y2 = MyX, MyY
	end
	if (x1 == -1 or x2 == -1) then
		return -1
	end
	local x_delta = math.abs(x2 - x1)
	local y_delta = math.abs(y2 - y1)

	if x_delta > y_delta then
		return x_delta
	end

	return y_delta
end
---------------------------------------------------------------------------
function GetDistanceFromOwner(id)
---------------------------------------------------------------------------
	local x1, y1 = GetOwnerPosition(id)
	local x2, y2 = GetV(V_POSITION, id)
	if (x1 == -1 or x2 == -1) then
		return -1
	end
	return GetDistance(x1, y1, x2, y2)
end
---------------------------------------------------------------------------
function IsOutOfSight(id1, id2)
---------------------------------------------------------------------------
	local x1, y1 = GetV(V_POSITION, id1)
	local x2, y2 = GetV(V_POSITION, id2)
	if (x1 == -1) or (x2 == -1) then
		return true
	end
	---------------------
	if OwnerID ~= nil then
		if BlockDistance2(OwnerID, id2) >= 0 and BlockDistance2(OwnerID, id2) < MaxDistance then
			return false
		end
	end
	---------------------
	return true
end
---------------------------------------------------------------------------
function IsInAttackSight(id1, id2)
---------------------------------------------------------------------------
	local x1, y1 = GetV(V_POSITION, id1)
	local x2, y2 = GetV(V_POSITION, id2)
	if (x1 == -1) or (x2 == -1) then
		return false
	end
	local d = GetDistance(x1, y1, x2, y2)
	if GetV(V_ATTACKRANGE, id1) >= d then
		return true
	else
		return false
	end
end